local mod_gui = require("mod-gui")
local RPG = require 'modules.rpg.table'--添加RPG数据连接
local WPT = require 'maps.mountain_fortress_v3.table'
require("modules.qol.baseapi")--添加快捷栏备份base

local Misc = require 'commands.misc'
local Event = require 'utils.event'
local Global = require 'utils.global'
local ComfyGui = require 'comfy_panel.main'
local Gui = require 'utils.gui'
local item_name={

	'wooden-chest',
	'iron-chest',
	'steel-chest',
	'storage-tank',
	'transport-belt',
	'fast-transport-belt',
	'express-transport-belt',
	'underground-belt',
	'fast-underground-belt',
	'express-underground-belt',
	'splitter',
	'fast-splitter',
	'express-splitter',
	'loader',
	'fast-loader',
	'express-loader',
	'burner-inserter',
	'inserter',
	'long-handed-inserter',
	'fast-inserter',
	'filter-inserter',
	'stack-inserter',
	'stack-filter-inserter',
	'small-electric-pole',
	'medium-electric-pole',
	'big-electric-pole',
	'substation',
	'pipe',
	'pipe-to-ground',
	'pump',
	'rail',
	'train-stop',
	'rail-signal',
	'rail-chain-signal',
	'locomotive',
	'cargo-wagon',
	'fluid-wagon',
	'artillery-wagon',
	'car',
	'tank',
	'spidertron',
	'spidertron-remote',
	'logistic-robot',
	'construction-robot',
	'logistic-chest-active-provider',
	'logistic-chest-passive-provider',
	'logistic-chest-storage',
	'logistic-chest-buffer',
	'logistic-chest-requester',
	'roboport',
	'small-lamp',
	'red-wire',
	'green-wire',
	'arithmetic-combinator',
	'decider-combinator',
	'constant-combinator',
	'power-switch',
	'programmable-speaker',
	'stone-brick',
	'concrete',
	'hazard-concrete',
	'refined-concrete',
	'refined-hazard-concrete',
	'landfill',
	'cliff-explosives',
	'repair-pack',
	'blueprint',
	'deconstruction-planner',
	'upgrade-planner',
	'blueprint-book',
	'copy-paste-tool',
	'cut-paste-tool',
	'boiler',
	'steam-engine',
	'solar-panel',
	'accumulator',
	'nuclear-reactor',
	'heat-pipe',
	'heat-exchanger',
	'steam-turbine',
	'burner-mining-drill',
	'electric-mining-drill',
	'offshore-pump',
	'pumpjack',
	'stone-furnace',
	'steel-furnace',
	'electric-furnace',
	'assembling-machine-1',
	'assembling-machine-2',
	'assembling-machine-3',
	'oil-refinery',
	'chemical-plant',
	'centrifuge',
	'lab',
	'beacon',
	'speed-module',
	'speed-module-2',
	'speed-module-3',
	'effectivity-module',
	'effectivity-module-2',
	'effectivity-module-3',
	'productivity-module',
	'productivity-module-2',
	'productivity-module-3',
	'rocket-silo',
	'satellite',
	'wood',
	'coal',
	'stone',
	'iron-ore',
	'copper-ore',
	'uranium-ore',
	'raw-fish',
	'iron-plate',
	'copper-plate',
	'solid-fuel',
	'steel-plate',
	'plastic-bar',
	'sulfur',
	'battery',
	'explosives',
	'crude-oil-barrel',
	'heavy-oil-barrel',
	'light-oil-barrel',
	'lubricant-barrel',
	'petroleum-gas-barrel',
	'sulfuric-acid-barrel',
	'water-barrel',
	'copper-cable',
	'iron-stick',
	'iron-gear-wheel',
	'empty-barrel',
	'electronic-circuit',
	'advanced-circuit',
	'processing-unit',
	'engine-unit',
	'electric-engine-unit',
	'flying-robot-frame',
	'rocket-control-unit',
	'low-density-structure',
	'rocket-fuel',
	'rocket-part',
	'nuclear-fuel',
	'uranium-235',
	'uranium-238',
	'uranium-fuel-cell',
	'used-up-uranium-fuel-cell',
	'automation-science-pack',
	'logistic-science-pack',
	'military-science-pack',
	'chemical-science-pack',
	'production-science-pack',
	'utility-science-pack',
	'space-science-pack',
	'coin',
	'pistol',
	'submachine-gun',
	'tank-machine-gun',
	'vehicle-machine-gun',
	'tank-flamethrower',
	'shotgun',
	'combat-shotgun',
	'rocket-launcher',
	'flamethrower',
	'land-mine',
	'artillery-wagon-cannon',
	'spidertron-rocket-launcher-1',
	'spidertron-rocket-launcher-2',
	'spidertron-rocket-launcher-3',
	'spidertron-rocket-launcher-4',
	'tank-cannon',
	'firearm-magazine',
	'piercing-rounds-magazine',
	'uranium-rounds-magazine',
	'shotgun-shell',
	'piercing-shotgun-shell',
	'cannon-shell',
	'explosive-cannon-shell',
	'uranium-cannon-shell',
	'explosive-uranium-cannon-shell',
	'artillery-shell',
	'rocket',
	'explosive-rocket',
	'atomic-bomb',
	'flamethrower-ammo',
	'grenade',
	'cluster-grenade',
	'poison-capsule',
	'slowdown-capsule',
	'defender-capsule',
	'distractor-capsule',
	'destroyer-capsule',
	'light-armor',
	'heavy-armor',
	'modular-armor',
	'power-armor',
	'power-armor-mk2',
	'solar-panel-equipment',
	'fusion-reactor-equipment',
	'battery-equipment',
	'battery-mk2-equipment',
	'belt-immunity-equipment',
	'exoskeleton-equipment',
	'personal-roboport-equipment',
	'personal-roboport-mk2-equipment',
	'night-vision-equipment',
	'energy-shield-equipment',
	'energy-shield-mk2-equipment',
	'personal-laser-defense-equipment',
	'discharge-defense-equipment',
	'discharge-defense-remote',
	'stone-wall',
	'gate',
	'gun-turret',
	'laser-turret',
	'flamethrower-turret',
	'artillery-turret',
	'artillery-targeting-remote',
	'radar',
	'player-port',
	'electric-energy-interface',
	'linked-chest',
	'heat-interface',
	'linked-belt',
	'infinity-chest',
	'infinity-pipe',
	'selection-tool',
	'item-with-inventory',
	'item-with-label',
	'item-with-tags',
	'simple-entity-with-force',
	'simple-entity-with-owner',
	'burner-generator',
	}
local this = {
    players = {},
    activate_custom_buttons = false,
    bottom_right = false,
    bottom_quickbar_button = {},
	bottom_donationitems_main = {},
}

Global.register(
    this,
    function(t)
        this = t
    end
)

local Public = {}

local bottom_guis_frame = Gui.uid_name()
local clear_corpse_button_name = Gui.uid_name()
local bottom_quickbar_button_name = Gui.uid_name()
local xp_uptime_2 = Gui.uid_name()--添加2倍经验
local xp_uptime_4 = Gui.uid_name()--添加4倍经验
local xp_uptime_6 = Gui.uid_name()--添加6倍经验
local xp_uptime_8 = Gui.uid_name()--添加8倍经验
local xp_uptime_10 = Gui.uid_name()--添加10倍经验

local charge = Gui.uid_name()--添加代码
local ShortcutBarBackup = Gui.uid_name()--添加代码
local contribute_item = Gui.uid_name()--贡献物品

local all_ore_to_coal = Gui.uid_name()--添加代码
local all_ore_to_stone = Gui.uid_name()--添加代码
local all_ore_to_iron_ore = Gui.uid_name()--添加代码
local all_ore_to_copper_ore = Gui.uid_name()--添加代码
local all_ore_to_uranium_ore = Gui.uid_name()--添加代码



function Public.get_player_data(player, remove_user_data)
    if remove_user_data then
        if this.players[player.index] then
            this.players[player.index] = nil
        end
        return
    end
    if not this.players[player.index] then
        this.players[player.index] = {}
    end
    return this.players[player.index]
end

function Public.get(key)
    if key then
        return this[key]
    else
        return this
    end
end

function Public.set(key, value)
    if key and (value or value == false) then
        this[key] = value
        return this[key]
    elseif key then
        return this[key]
    else
        return this
    end
end

Event.on_init(
    function()
        this.players = {}
    end
)

function Public.reset()
    this.players = {}
end

----! Gui Functions ! ----

local function create_frame(player, rebuild)




    local gui = player.gui
    local frame = gui.screen[bottom_guis_frame]
    if frame and frame.valid then
        if rebuild then
            frame.destroy()
        else
            return frame
        end
    end

    frame =
        player.gui.screen.add {
        type = 'frame',
        name = bottom_guis_frame,
        direction = 'vertical'
    }
    frame.style.padding = 3
    frame.style.minimal_height = 48--高度
    frame.style.top_padding = 4

    local inner_frame =
        frame.add {
        type = 'frame',
        direction = 'horizontal'--横向 
    }
    inner_frame.style = 'quick_bar_inner_panel'

    inner_frame.add {
        type = 'sprite-button',
        sprite = 'entity/behemoth-biter',
        name = clear_corpse_button_name,
        tooltip = {'commands.clear_corpse'},
        style = 'quick_bar_page_button'
    }

    local bottom_quickbar_button =
        inner_frame.add {
        type = 'sprite-button',
        name = bottom_quickbar_button_name,
        style = 'quick_bar_page_button'
    }
	-----------------------添加矿石转化[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
    --充电
	
    local inner_frame_112 =
        frame.add {
        type = 'frame',
        direction = 'horizontal'--横向 
    }
    inner_frame_112.style = 'quick_bar_inner_panel'
	
	
    local inner_frame_113 =
        frame.add {
        type = 'frame',
        direction = 'horizontal'--横向 
    }
    inner_frame_113.style = 'quick_bar_inner_panel'
	inner_frame_113.style.font_color = {255, 0, 0}

	inner_frame.add {
        type = 'sprite-button',
        sprite = 'item/battery-mk2-equipment',
        name = charge,
        tooltip = {'charge'},
        style = 'quick_bar_page_button'
    }
	inner_frame.add {
        type = 'sprite-button',
        sprite = 'virtual-signal/signal-B',
        name = ShortcutBarBackup,
        tooltip = {'ShortcutBarBackup'},
        style = 'quick_bar_page_button'
    }
	--contribute_item
	inner_frame.add {
        type = 'sprite-button',
        sprite = 'virtual-signal/signal-U',
        name = contribute_item,
        tooltip = {'contribute_item'},
        style = 'quick_bar_page_button'
    }
	inner_frame_113.add {
        type = 'sprite-button',
        caption = '2倍',
        name = xp_uptime_2,
        tooltip = {'xp_uptime_2'},
        style = 'quick_bar_page_button'
    }
	inner_frame_113.add {
        type = 'sprite-button',
        caption = '4倍',
        name = xp_uptime_4,
        tooltip = {'xp_uptime_4'},
        style = 'quick_bar_page_button'
    }
	inner_frame_113.add {
        type = 'sprite-button',
        caption = '6倍',
        name = xp_uptime_6,
        tooltip = {'xp_uptime_6'},
        style = 'quick_bar_page_button'
    }
	inner_frame_113.add {
        type = 'sprite-button',
        caption = '8倍',
        name = xp_uptime_8,
        tooltip = {'xp_uptime_8'},
        style = 'quick_bar_page_button'
    }
	inner_frame_113.add {
        type = 'sprite-button',
        caption = '10倍',
        name = xp_uptime_10,
        tooltip = {'xp_uptime_10'},
        style = 'quick_bar_page_button'
    }
	
	inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/coal',
        name = all_ore_to_coal,
        tooltip = {'all_ore_to_coal1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/stone',
        name = all_ore_to_stone,
        tooltip = {'all_ore_to_stone1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/iron-ore',
        name = all_ore_to_iron_ore,
        tooltip = {'all_ore_to_iron_ore1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/copper-ore',
        name = all_ore_to_copper_ore,
        tooltip = {'all_ore_to_copper_ore1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/uranium-ore',
        name = all_ore_to_uranium_ore,
        tooltip = {'all_ore_to_uranium_ore1'},
        style = 'quick_bar_page_button'
    }
	
	
	-----------------
    this.bottom_quickbar_button[player.index] = {name = bottom_quickbar_button_name, frame = bottom_quickbar_button}

    if this.bottom_quickbar_button.sprite and this.bottom_quickbar_button.tooltip then
        bottom_quickbar_button.sprite = this.bottom_quickbar_button.sprite
        bottom_quickbar_button.tooltip = this.bottom_quickbar_button.tooltip
    end

    return frame
end

local function set_location(player)
    local frame = create_frame(player)
    local resolution = player.display_resolution
    local scale = player.display_scale

    if this.players[player.index] and this.players[player.index].bottom_left then
        frame.location = {
            x = (resolution.width / 2) - ((54 + 445) * scale),
            y = (resolution.height - (144 * scale))--底部0 1格 48
        }
        return
    end

    if this.bottom_right then
        frame.location = {
            x = (resolution.width / 2) - ((54 + -628) * scale),
            y = (resolution.height - (144 * scale))--底部0 1格 48
        }
    else
        local experimental = get_game_version()
        if experimental then
            frame.location = {
                x = (resolution.width / 2) - ((54 + 445) * scale),
                y = (resolution.height - (144 * scale))--底部0 1格 48
            }
        else
            frame.location = {
                x = (resolution.width / 2) - ((54 + 258) * scale),
                y = (resolution.height - (144 * scale))--底部0 1格 48
            }
        end
    end
end

--- Activates the custom buttons
---@param boolean
function Public.activate_custom_buttons(value)
    if value then
        this.activate_custom_buttons = value
    else
        this.activate_custom_buttons = false
    end
end

--- Fetches if the custom buttons are activated
function Public.is_custom_buttons_enabled()
    return this.activate_custom_buttons
end

--- Sets the buttons to be aligned bottom right
---@param boolean
function Public.bottom_right(value)
    if value then
        this.bottom_right = value
    else
        this.bottom_right = false
    end
end

Gui.on_click(
    clear_corpse_button_name,
    function(event)
        Misc.clear_corpses(event)
    end
)

--添加代码开始
--快捷栏备份
Gui.on_click(
    ShortcutBarBackup,
    function(event)
	
		
        local player = game.players[event.player_index]
	
	
		local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
		if window ~= nil then window.destroy() return end
		local window = mod_gui.get_frame_flow(player).add { type = "frame", name = "ShortcutBarAndLogistics_listBackup", direction = "vertical", style = "inner_frame_in_outer_frame", caption = { 'window-label.ShortcutBarAndLogistics_listBackup' } }
		local label_Shortcut_bar = window.add { type = "label", name = "label_Shortcut_bar", caption = { 'window-label.label_Shortcut_bar' }, tooltip = { 'window-label.label_Shortcut_bar_tip' } }
		label_Shortcut_bar.style.single_line = false
		local text_box_Shortcut_bar = window.add { type = "text-box", name = "text_box_Shortcut_bar" }
		text_box_Shortcut_bar.style.height = 40
		text_box_Shortcut_bar.style.width = 400
		text_box_Shortcut_bar.style.top_margin = 4
		text_box_Shortcut_bar.style.bottom_margin = 4
		local button_flow_1 = window.add { type = "flow", name = "button_flow_1", direction = "horizontal" }
		button_flow_1.add { type = "button", name = "button_Shortcut_bar_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_backups' } }
		button_flow_1.add { type = "button", name = "button_Shortcut_bar_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_recovery' } }
		button_flow_1.add { type = "label", name = "box_Shortcut_bar", caption = "", }
		local label_Logistics_list = window.add { type = "label", name = "label_Logistics_list", caption = { 'window-label.label_Logistics_list' }, tooltip = { 'window-label.label_Logistics_list_tip' } }
		label_Logistics_list.style.single_line = false
		local text_box_Logistics_list = window.add { type = "text-box", name = "text_box_Logistics_list" }
		text_box_Logistics_list.style.height = 40
		text_box_Logistics_list.style.width = 400
		text_box_Logistics_list.style.top_margin = 4
		text_box_Logistics_list.style.bottom_margin = 4
		local button_flow_2 = window.add { type = "flow", name = "button_flow_2", direction = "horizontal" }
		button_flow_2.add { type = "button", name = "button_Logistics_list_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_backups' } }
		button_flow_2.add { type = "button", name = "button_Logistics_list_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_recovery' } }
		button_flow_2.add { type = "label", name = "box_Logistics_list", caption = "" }
		window.add { type = "button", name = "back_button", style = "back_button", caption = { 'window-label.back_button' } }


    end
)
--contribute_item
local function clear_gui(player)


    local data = this.bottom_donationitems_main[player.index]
    if not data then
        return
    end
    if data.frame and data.frame.valid then
        Gui.remove_data_recursively(data.frame)
        data.frame.destroy()
    end
    this.bottom_donationitems_main[player.index] = nil

end



Gui.on_click(
    contribute_item,
    function(event)
        local locomotiveitems = WPT.get('locomotiveitems')
		local player = game.players[event.player_index]
		local control = event.control
		
		if event.button == defines.mouse_button_type.left then 
			if not player.character then
				player.print('you are character is nil')
				goto continue
			end
			player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间character_trash
			if not player_trash and not player_trash.valid then
				player.print('you are [player_main] is nil')
				
				goto continue
			end
			if player_trash.is_empty() then
				goto continue
			end
			for index, name in ipairs(item_name) do
				local itemcout = player_trash.get_item_count(name)
				if itemcout > 0 then  
					locomotiveitems[name] = locomotiveitems[name] + itemcout
					player_trash.remove({name = name,count = itemcout})
				end
			end
		elseif event.button == defines.mouse_button_type.right then
			--开关界面
			if  clear_gui(player) then
				goto continue
			end
			--打开界面
			local frame =
				player.gui.screen.add {
				type = 'frame',
				caption = player.name .. '´打开的公共矿物处理',
				direction = 'vertical',
				name = 'Donationitems_main' .. player.name
			}
			frame.auto_center = true
			local tbl = frame.add {type = 'table', column_count = 23, name = 'personal_inventory'}
			local btn
			for item_name, item_count in pairs(locomotiveitems) do
				btn =
					tbl.add {
					type = 'sprite-button',
					sprite = 'item/' .. item_name,
					style = 'slot_button',
					number = item_count,
					name = item_name
				}
				btn.enabled = true
				btn.style.height = size
				btn.style.width = size
				btn.focus()
			end
			frame.add{type = "line"}
			local frame_close =frame.add{type = "button",name = 'Donationitems_main_close',caption = '关闭'}
			frame_close.style.font = 'heading-2'
			frame_close.style.padding = 2
			frame_close.style.top_margin = 3
			frame_close.style.left_margin = 750
			frame_close.style.horizontal_align = 'center'
			frame_close.style.vertical_align = 'center'
			this.bottom_donationitems_main[player.index]=
			{
				frame = frame
			}
			goto continue
		end
		
		 ::continue::
    end
)


Gui.on_click(
	xp_uptime_2,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 10000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 10000})
			
			
			if rpg_t[player.index].xp_uptime_2 >=  game.tick then
				rpg_t[player.index].xp_uptime_2 = rpg_t[player.index].xp_uptime_2 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_2 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_2 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_2 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟双倍经验，2 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足10K.无法购买双倍经验......')
		end
	end

)
Gui.on_click(
	xp_uptime_4,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 50000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 50000})
			
			
			if rpg_t[player.index].xp_uptime_4 >=  game.tick then
				rpg_t[player.index].xp_uptime_4 = rpg_t[player.index].xp_uptime_4 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_4 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_4 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_4 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 4 倍经验，4 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足50K.无法购买 4 倍经验......')
		end
	end

)
Gui.on_click(
	xp_uptime_6,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 200000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 200000})
			
			
			if rpg_t[player.index].xp_uptime_6 >=  game.tick then
				rpg_t[player.index].xp_uptime_6 = rpg_t[player.index].xp_uptime_6 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_6 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_6 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_6 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 6 倍经验，6 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足200K.无法购买 6 倍经验......')
		end
	end

)
Gui.on_click(
	xp_uptime_8,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 500000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 500000})
			
			
			if rpg_t[player.index].xp_uptime_8 >=  game.tick then
				rpg_t[player.index].xp_uptime_8 = rpg_t[player.index].xp_uptime_8 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_8 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_8 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_8 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 8 倍经验，8 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足500K.无法购买 8 倍经验......')
		end
	end

)
Gui.on_click(
	xp_uptime_10,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 1000000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 1000000})
			
			
			if rpg_t[player.index].xp_uptime_10 >=  game.tick then
				rpg_t[player.index].xp_uptime_10 = rpg_t[player.index].xp_uptime_10 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_10 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_10 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_10 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 10 倍经验，10 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足1000000K.无法购买 10 倍经验......')
		end
	end

)

--充电

Gui.on_click(
    charge,
    function(event)
	
		
        local player = game.players[event.player_index]
	
	
		if not player.character then
			player.print('you are character is nil')
			return
		end
		local armor_inventory = player.get_inventory(defines.inventory.character_armor)
		if not armor_inventory.valid then
			
			player.print('you are [armor_inventory] is nil')
			return
		end
		local armor = armor_inventory[1]
		if not armor.valid_for_read then
			player.print('you are [armor.valid_for_read] not read')
			return
		end
		local grid = armor.grid
		if not grid or not grid.valid then
			player.print('you are [grid.valid] not read')
			return
		end
		local in_energy = 0--10MJ  10000
		local equip = grid.equipment
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number <= 100 and coin_number > 0 then
			in_energy = coin_number * 100000
			player_main.remove({name = 'coin',count = coin_number})
		elseif coin_number > 100 then
			player_main.remove({name = 'coin',count = 100})
			in_energy = 10000000
		else
			goto TT
		end
		
		for _, piece in pairs(equip) do
			if piece.valid and piece.generator_power == 0 then
				local energy_needs = piece.max_energy - piece.energy--energy_needs能量差值
				if energy_needs > 0 then
					if in_energy > 0 then
						if in_energy > energy_needs then
							in_energy = in_energy - energy_needs
							piece.energy = piece.max_energy
						else 
							piece.energy = piece.energy + in_energy
							in_energy = 0
							goto TT
						end
					else
						goto TT
					end
					
				end
			end
		end
		::TT::
		if in_energy > 100000 then 
			player.insert({name = 'coin' ,count = math.floor(in_energy/100000)})--修改
			player.print('返还 ' .. math.floor(in_energy/100000) .. ' 枚金币')
		end
    end
)

Gui.on_click(
		all_ore_to_coal,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		local player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		--local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = stone_number  + iron_number + copper_number + uranium_number
		
		--if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'coal' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_coal', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_coal0'})--修改
		end
		if control then 
			--local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = stone_number  + iron_number + copper_number + uranium_number
			
			--if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'coal' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_coal', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_coal0'})--修改
			end
		end
    end
	)

Gui.on_click(
    all_ore_to_stone,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		--local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + iron_number + copper_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		--if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'stone' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_stone', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_stone0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			--local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + iron_number + copper_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			--if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'stone' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_stone', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_stone0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_iron_ore,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		--local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + copper_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		--if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'iron-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_iron_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_iron_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			--local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + copper_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			--if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'iron-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_iron_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_iron_ore0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_copper_ore,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		--local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + iron_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		--if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'copper-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_copper_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_copper_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			--local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + iron_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			--if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'copper-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_copper_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_copper_ore0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_uranium_ore,
    function(event)
        local player = game.players[event.player_index]
		if player.name ~= '' then
			player.print('当前模式暂时不开放[item=uranium-ore]转化')
			return
		end
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		--local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + iron_number + copper_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		--if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'uranium-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_uranium_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_uranium_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			--local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + iron_number + copper_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			--if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'uranium-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_uranium_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_uranium_ore0'})--修改
			end
		end
    end
)
--添加代码结束
Event.add(
    defines.events.on_player_joined_game,
    function(event)
        local player = game.players[event.player_index]
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_player_display_resolution_changed,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_player_respawned,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_player_died,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            local frame = player.gui.screen[bottom_guis_frame]
            if frame and frame.valid then
                frame.destroy()
            end
        end
    end
)

Event.add(
    defines.events.on_player_display_scale_changed,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_gui_click,
    function(event)
		if not event then
			return
		end

		if not event.element then
			return
		end
		if not event.element.valid then
			return
		end
		if not event.element.name then
			return
		end
		
		local player = game.players[event.player_index]
		
		if event.element.name == 'Donationitems_main_close' then
			clear_gui(player)
			return
		end
		local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
		if event.element.type == "text-box" then
			event.element.select_all()
		elseif event.element.name == 'button_Shortcut_bar_backups' then
			local text_box = window['text_box_Shortcut_bar']
			text_box.text = get_Shortcut_bar_text(player)
			text_box.select_all()
			text_box.focus()
		elseif event.element.name == 'button_Shortcut_bar_recovery' then
			local text_box = window['text_box_Shortcut_bar']
			local encoded_string = text_box.text
			if encoded_string == "" then
				dump("字符串解码失败，请重新输入", player)
				text_box.focus()
				return
			else
				local decoded_string = game.decode_string(encoded_string)
				if decoded_string == nil then
					dump("字符串解码失败，请重新输入", player)
					text_box.focus()
					return
				else
					if type(game.json_to_table(decoded_string)) ~= "table" then
						dump("非法的字符串，请重新输入", player)
						text_box.focus()
						return
					end
					for index, name in ipairs(game.json_to_table(decoded_string)) do
						local status = pcall(recovery_Shortcut_bar, player, index, name)
						if not status then
							dump("【" .. name .. "】物品已经不存在了")
						end
					end
				end
			end
			dump("恢复快捷栏成功")
		elseif event.element.name == 'button_Logistics_list_backups' then
			-- if DoesRobotResearch(player.force) == false then
				-- dump("解锁物流机器人后才能使用此功能")
				-- return
			-- end
			local text_box = window["text_box_Logistics_list"]
			text_box.text = get_Logistics_list_text(player)
			text_box.select_all()
			text_box.focus()
		elseif event.element.name == 'button_Logistics_list_recovery' then
			-- if DoesRobotResearch(player.force) == false then
				-- dump("解锁物流机器人后才能使用此功能")
				-- return
			-- end
			local text_box = window['text_box_Logistics_list']
			local encoded_string = text_box.text
			if encoded_string == "" then
				dump("字符串解码失败，请重新输入", player)
				text_box.focus()
				return
			else
				local decoded_string = game.decode_string(encoded_string)
				if decoded_string == nil then
					dump("字符串解码失败，请重新输入", player)
					text_box.focus()
					return
				else
					local pl_slots = game.json_to_table(decoded_string)
					if type(pl_slots) ~= "table" then
						dump("非法的字符串，请重新输入", player)
						text_box.focus()
						return
					end
					for index, slot in ipairs(pl_slots) do
						local status = pcall(recovery_Logistics_list, player, index, slot)
						if not status then
	--                        dump("【" .. name .. "】物品已经不存在了")
						end
					end
				end
			end
			dump("恢复物流需求列表成功")
		elseif event.element.name == 'back_button' then
			window.destroy()
		end
    end
)
local on_tick = function()
	local tick = game.tick
	if  tick % 18000 == 0 then
		local locomotiveitems = WPT.get('locomotiveitems')
		local map_name = 'mountain_fortress_v3'
		game.print('清理地图所有宝箱物品到公共仓库(5分钟/次)')
		for _, surface in pairs(game.surfaces) do
			if string.sub(surface.name, 0, #map_name) == map_name then
				for chunk in surface.get_chunks() do
					if chunk.x < 8 and chunk.x > -9 then
						for _, chests in pairs(surface.find_entities_filtered{area=chunk.area, type='container',force = 'neutral'}) do
							
							if not chests or not chests.valid then
								goto continue
							end
							local chests_inventory = chests.get_inventory(defines.inventory.chest)
							if not chests_inventory or not chests_inventory.valid then
								goto continue
							end
							if chests_inventory.is_empty() then
								chests.damage(9999999999, 'enemy', 'explosion')
								goto continue
							end
							for index, name in ipairs(item_name) do
								local itemcout = chests_inventory.get_item_count(name)
								if itemcout > 0 then  
									locomotiveitems[name] = locomotiveitems[name] + itemcout
									chests_inventory.remove({name = name,count = itemcout})
								end
							end
							chests.damage(9999999999, 'enemy', 'explosion')
							::continue::
						end
					end
				end
			
			end
		end
		
	end
	
end
Event.on_nth_tick(15, on_tick)
Public.bottom_guis_frame = bottom_guis_frame
Public.set_location = set_location
ComfyGui.screen_to_bypass(bottom_guis_frame)

return Public
