local mod_gui = require("mod-gui")
local RPG = require 'modules.rpg.table'--添加RPG数据连接
require("modules.qol.baseapi")--添加快捷栏备份base
local WPT = require 'maps.mountain_fortress_v3.table'

local Event = require 'utils.event'
local Global = require 'utils.global'
local ComfyGui = require 'comfy_panel.main'
local Gui = require 'utils.gui'
local all_item_name={

	'wooden-chest',
	'iron-chest',
	'steel-chest',
	'storage-tank',
	'transport-belt',
	'fast-transport-belt',
	'express-transport-belt',
	'underground-belt',
	'fast-underground-belt',
	'express-underground-belt',
	'splitter',
	'fast-splitter',
	'express-splitter',
	'loader',
	'fast-loader',
	'express-loader',
	'burner-inserter',
	'inserter',
	'long-handed-inserter',
	'fast-inserter',
	'filter-inserter',
	'stack-inserter',
	'stack-filter-inserter',
	'small-electric-pole',
	'medium-electric-pole',
	'big-electric-pole',
	'substation',
	'pipe',
	'pipe-to-ground',
	'pump',
	'rail',
	'train-stop',
	'rail-signal',
	'rail-chain-signal',
	'locomotive',
	'cargo-wagon',
	'fluid-wagon',
	'artillery-wagon',
	'car',
	'tank',
	'spidertron',
	'spidertron-remote',
	'logistic-robot',
	'construction-robot',
	'logistic-chest-active-provider',
	'logistic-chest-passive-provider',
	'logistic-chest-storage',
	'logistic-chest-buffer',
	'logistic-chest-requester',
	'roboport',
	'small-lamp',
	'red-wire',
	'green-wire',
	'arithmetic-combinator',
	'decider-combinator',
	'constant-combinator',
	'power-switch',
	'programmable-speaker',
	'stone-brick',
	'concrete',
	'hazard-concrete',
	'refined-concrete',
	'refined-hazard-concrete',
	'landfill',
	'cliff-explosives',
	'repair-pack',
	'blueprint',
	'deconstruction-planner',
	'upgrade-planner',
	'blueprint-book',
	'copy-paste-tool',
	'cut-paste-tool',
	'boiler',
	'steam-engine',
	'solar-panel',
	'accumulator',
	'nuclear-reactor',
	'heat-pipe',
	'heat-exchanger',
	'steam-turbine',
	'burner-mining-drill',
	'electric-mining-drill',
	'offshore-pump',
	'pumpjack',
	'stone-furnace',
	'steel-furnace',
	'electric-furnace',
	'assembling-machine-1',
	'assembling-machine-2',
	'assembling-machine-3',
	'oil-refinery',
	'chemical-plant',
	'centrifuge',
	'lab',
	'beacon',
	'speed-module',
	'speed-module-2',
	'speed-module-3',
	'effectivity-module',
	'effectivity-module-2',
	'effectivity-module-3',
	'productivity-module',
	'productivity-module-2',
	'productivity-module-3',
	'rocket-silo',
	'satellite',
	'wood',
	'coal',
	'stone',
	'iron-ore',
	'copper-ore',
	'uranium-ore',
	'raw-fish',
	'iron-plate',
	'copper-plate',
	'solid-fuel',
	'steel-plate',
	'plastic-bar',
	'sulfur',
	'battery',
	'explosives',
	'crude-oil-barrel',
	'heavy-oil-barrel',
	'light-oil-barrel',
	'lubricant-barrel',
	'petroleum-gas-barrel',
	'sulfuric-acid-barrel',
	'water-barrel',
	'copper-cable',
	'iron-stick',
	'iron-gear-wheel',
	'empty-barrel',
	'electronic-circuit',
	'advanced-circuit',
	'processing-unit',
	'engine-unit',
	'electric-engine-unit',
	'flying-robot-frame',
	'rocket-control-unit',
	'low-density-structure',
	'rocket-fuel',
	'rocket-part',
	'nuclear-fuel',
	'uranium-235',
	'uranium-238',
	'uranium-fuel-cell',
	'used-up-uranium-fuel-cell',
	'automation-science-pack',
	'logistic-science-pack',
	'military-science-pack',
	'chemical-science-pack',
	'production-science-pack',
	'utility-science-pack',
	'space-science-pack',
	'coin',
	'pistol',
	'submachine-gun',
	'tank-machine-gun',
	'vehicle-machine-gun',
	'tank-flamethrower',
	'shotgun',
	'combat-shotgun',
	'rocket-launcher',
	'flamethrower',
	'land-mine',
	'artillery-wagon-cannon',
	'spidertron-rocket-launcher-1',
	'spidertron-rocket-launcher-2',
	'spidertron-rocket-launcher-3',
	'spidertron-rocket-launcher-4',
	'tank-cannon',
	'firearm-magazine',
	'piercing-rounds-magazine',
	'uranium-rounds-magazine',
	'shotgun-shell',
	'piercing-shotgun-shell',
	'cannon-shell',
	'explosive-cannon-shell',
	'uranium-cannon-shell',
	'explosive-uranium-cannon-shell',
	'artillery-shell',
	'rocket',
	'explosive-rocket',
	'atomic-bomb',
	'flamethrower-ammo',
	'grenade',
	'cluster-grenade',
	'poison-capsule',
	'slowdown-capsule',
	'defender-capsule',
	'distractor-capsule',
	'destroyer-capsule',
	'light-armor',
	'heavy-armor',
	'modular-armor',
	'power-armor',
	'power-armor-mk2',
	'solar-panel-equipment',
	'fusion-reactor-equipment',
	'battery-equipment',
	'battery-mk2-equipment',
	'belt-immunity-equipment',
	'exoskeleton-equipment',
	'personal-roboport-equipment',
	'personal-roboport-mk2-equipment',
	'night-vision-equipment',
	'energy-shield-equipment',
	'energy-shield-mk2-equipment',
	'personal-laser-defense-equipment',
	'discharge-defense-equipment',
	'discharge-defense-remote',
	'stone-wall',
	'gate',
	'gun-turret',
	'laser-turret',
	'flamethrower-turret',
	'artillery-turret',
	'artillery-targeting-remote',
	'radar',
	'player-port',
	'electric-energy-interface',
	'linked-chest',
	'heat-interface',
	'linked-belt',
	'infinity-chest',
	'infinity-pipe',
	'selection-tool',
	'item-with-inventory',
	'item-with-label',
	'item-with-tags',
	'simple-entity-with-force',
	'simple-entity-with-owner',
	'burner-generator',
	}

local this = {
	players_pos = {},
    players = {},
    activate_custom_buttons = true,--激活自定义按钮
    bottom_right = true,
    bottom_quickbar_button_112 = {},
	players_donationitems_main_location = {},
	Everybody_items_count = { --locomotiveitems转名字Everybody_items_count
		['wooden-chest'] = 0,
		['iron-chest'] = 0,
		['steel-chest'] = 0,
		['storage-tank'] = 0,
		['transport-belt'] = 0,
		['fast-transport-belt'] = 0,
		['express-transport-belt'] = 0,
		['underground-belt'] = 0,
		['fast-underground-belt'] = 0,
		['express-underground-belt'] = 0,
		['splitter'] = 0,
		['fast-splitter'] = 0,
		['express-splitter'] = 0,
		['loader'] = 0,
		['fast-loader'] = 0,
		['express-loader'] = 0,
		['burner-inserter'] = 0,
		['inserter'] = 0,
		['long-handed-inserter'] = 0,
		['fast-inserter'] = 0,
		['filter-inserter'] = 0,
		['stack-inserter'] = 0,
		['stack-filter-inserter'] = 0,
		['small-electric-pole'] = 0,
		['medium-electric-pole'] = 0,
		['big-electric-pole'] = 0,
		['substation'] = 0,
		['pipe'] = 0,
		['pipe-to-ground'] = 0,
		['pump'] = 0,
		['rail'] = 0,
		['train-stop'] = 0,
		['rail-signal'] = 0,
		['rail-chain-signal'] = 0,
		['locomotive'] = 0,
		['cargo-wagon'] = 0,
		['fluid-wagon'] = 0,
		['artillery-wagon'] = 0,
		['car'] = 0,
		['tank'] = 0,
		['spidertron'] = 0,
		['spidertron-remote'] = 0,
		['logistic-robot'] = 0,
		['construction-robot'] = 0,
		['logistic-chest-active-provider'] = 0,
		['logistic-chest-passive-provider'] = 0,
		['logistic-chest-storage'] = 0,
		['logistic-chest-buffer'] = 0,
		['logistic-chest-requester'] = 0,
		['roboport'] = 0,
		['small-lamp'] = 0,
		['red-wire'] = 0,
		['green-wire'] = 0,
		['arithmetic-combinator'] = 0,
		['decider-combinator'] = 0,
		['constant-combinator'] = 0,
		['power-switch'] = 0,
		['programmable-speaker'] = 0,
		['stone-brick'] = 0,
		['concrete'] = 0,
		['hazard-concrete'] = 0,
		['refined-concrete'] = 0,
		['refined-hazard-concrete'] = 0,
		['landfill'] = 0,
		['cliff-explosives'] = 0,
		['repair-pack'] = 0,
		['blueprint'] = 0,
		['deconstruction-planner'] = 0,
		['upgrade-planner'] = 0,
		['blueprint-book'] = 0,
		['copy-paste-tool'] = 0,
		['cut-paste-tool'] = 0,
		['boiler'] = 0,
		['steam-engine'] = 0,
		['solar-panel'] = 0,
		['accumulator'] = 0,
		['nuclear-reactor'] = 0,
		['heat-pipe'] = 0,
		['heat-exchanger'] = 0,
		['steam-turbine'] = 0,
		['burner-mining-drill'] = 0,
		['electric-mining-drill'] = 0,
		['offshore-pump'] = 0,
		['pumpjack'] = 0,
		['stone-furnace'] = 0,
		['steel-furnace'] = 0,
		['electric-furnace'] = 0,
		['assembling-machine-1'] = 0,
		['assembling-machine-2'] = 0,
		['assembling-machine-3'] = 0,
		['oil-refinery'] = 0,
		['chemical-plant'] = 0,
		['centrifuge'] = 0,
		['lab'] = 0,
		['beacon'] = 0,
		['speed-module'] = 0,
		['speed-module-2'] = 0,
		['speed-module-3'] = 0,
		['effectivity-module'] = 0,
		['effectivity-module-2'] = 0,
		['effectivity-module-3'] = 0,
		['productivity-module'] = 0,
		['productivity-module-2'] = 0,
		['productivity-module-3'] = 0,
		['rocket-silo'] = 0,
		['satellite'] = 0,
		['wood'] = 0,
		['coal'] = 0,
		['stone'] = 0,
		['iron-ore'] = 0,
		['copper-ore'] = 0,
		['uranium-ore'] = 0,
		['raw-fish'] = 0,
		['iron-plate'] = 0,
		['copper-plate'] = 0,
		['solid-fuel'] = 0,
		['steel-plate'] = 0,
		['plastic-bar'] = 0,
		['sulfur'] = 0,
		['battery'] = 0,
		['explosives'] = 0,
		['crude-oil-barrel'] = 0,
		['heavy-oil-barrel'] = 0,
		['light-oil-barrel'] = 0,
		['lubricant-barrel'] = 0,
		['petroleum-gas-barrel'] = 0,
		['sulfuric-acid-barrel'] = 0,
		['water-barrel'] = 0,
		['copper-cable'] = 0,
		['iron-stick'] = 0,
		['iron-gear-wheel'] = 0,
		['empty-barrel'] = 0,
		['electronic-circuit'] = 0,
		['advanced-circuit'] = 0,
		['processing-unit'] = 0,
		['engine-unit'] = 0,
		['electric-engine-unit'] = 0,
		['flying-robot-frame'] = 0,
		['rocket-control-unit'] = 0,
		['low-density-structure'] = 0,
		['rocket-fuel'] = 0,
		['rocket-part'] = 0,
		['nuclear-fuel'] = 0,
		['uranium-235'] = 0,
		['uranium-238'] = 0,
		['uranium-fuel-cell'] = 0,
		['used-up-uranium-fuel-cell'] = 0,
		['automation-science-pack'] = 0,
		['logistic-science-pack'] = 0,
		['military-science-pack'] = 0,
		['chemical-science-pack'] = 0,
		['production-science-pack'] = 0,
		['utility-science-pack'] = 0,
		['space-science-pack'] = 0,
		['coin'] = 0,
		['pistol'] = 0,
		['submachine-gun'] = 0,
		['tank-machine-gun'] = 0,
		['vehicle-machine-gun'] = 0,
		['tank-flamethrower'] = 0,
		['shotgun'] = 0,
		['combat-shotgun'] = 0,
		['rocket-launcher'] = 0,
		['flamethrower'] = 0,
		['land-mine'] = 0,
		['artillery-wagon-cannon'] = 0,
		['spidertron-rocket-launcher-1'] = 0,
		['spidertron-rocket-launcher-2'] = 0,
		['spidertron-rocket-launcher-3'] = 0,
		['spidertron-rocket-launcher-4'] = 0,
		['tank-cannon'] = 0,
		['firearm-magazine'] = 0,
		['piercing-rounds-magazine'] = 0,
		['uranium-rounds-magazine'] = 0,
		['shotgun-shell'] = 0,
		['piercing-shotgun-shell'] = 0,
		['cannon-shell'] = 0,
		['explosive-cannon-shell'] = 0,
		['uranium-cannon-shell'] = 0,
		['explosive-uranium-cannon-shell'] = 0,
		['artillery-shell'] = 0,
		['rocket'] = 0,
		['explosive-rocket'] = 0,
		['atomic-bomb'] = 0,
		['flamethrower-ammo'] = 0,
		['grenade'] = 0,
		['cluster-grenade'] = 0,
		['poison-capsule'] = 0,
		['slowdown-capsule'] = 0,
		['defender-capsule'] = 0,
		['distractor-capsule'] = 0,
		['destroyer-capsule'] = 0,
		['light-armor'] = 0,
		['heavy-armor'] = 0,
		['modular-armor'] = 0,
		['power-armor'] = 0,
		['power-armor-mk2'] = 0,
		['solar-panel-equipment'] = 0,
		['fusion-reactor-equipment'] = 0,
		['battery-equipment'] = 0,
		['battery-mk2-equipment'] = 0,
		['belt-immunity-equipment'] = 0,
		['exoskeleton-equipment'] = 0,
		['personal-roboport-equipment'] = 0,
		['personal-roboport-mk2-equipment'] = 0,
		['night-vision-equipment'] = 0,
		['energy-shield-equipment'] = 0,
		['energy-shield-mk2-equipment'] = 0,
		['personal-laser-defense-equipment'] = 0,
		['discharge-defense-equipment'] = 0,
		['discharge-defense-remote'] = 0,
		['stone-wall'] = 0,
		['gate'] = 0,
		['gun-turret'] = 0,
		['laser-turret'] = 0,
		['flamethrower-turret'] = 0,
		['artillery-turret'] = 0,
		['artillery-targeting-remote'] = 0,
		['radar'] = 0,
		['player-port'] = 0,
		['electric-energy-interface'] = 0,
		['linked-chest'] = 0,
		['heat-interface'] = 0,
		['linked-belt'] = 0,
		['infinity-chest'] = 0,
		['infinity-pipe'] = 0,
		['selection-tool'] = 0,
		['item-with-inventory'] = 0,
		['item-with-label'] = 0,
		['item-with-tags'] = 0,
		['simple-entity-with-force'] = 0,
		['simple-entity-with-owner'] = 0,
		['burner-generator'] = 0,
	},

}

Global.register(
    this,
    function(t)
        this = t
    end
)

local Public = {}
function Public.chest_item_inst_Everybody_items_count(chest)
	for index, name in ipairs(all_item_name) do
		local itemcout = chest.get_item_count(name)
		if itemcout > 0 then  
			this.Everybody_items_count[name] = this.Everybody_items_count[name] + itemcout
			chest.remove({name = name,count = itemcout})
		end
	end
end
local bottom_guis_frame_111 = Gui.uid_name()
local bottom_quickbar_button_name_112 = Gui.uid_name()

local xp_uptime_2 = Gui.uid_name()--添加2倍经验
-- local xp_uptime_4 = Gui.uid_name()--添加4倍经验
-- local xp_uptime_6 = Gui.uid_name()--添加6倍经验
-- local xp_uptime_8 = Gui.uid_name()--添加8倍经验
-- local xp_uptime_10 = Gui.uid_name()--添加10倍经验
--添加2倍经验
Gui.on_click(
	xp_uptime_2,
	function(event)
		local player = game.players[event.player_index]
		local rpg_t = RPG.get('rpg_t')
		local add_xp_uptime = 10 * 60 * 60

		if not player.character then
			player.print('you are character is nil')
			return
		end
		
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		if not player_main and not player_main.valid then
			
			player.print('you are [player_main] is nil')
			return
		end
		
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number >= 10000 then--玩家背包大于10K
			player_main.remove({name = 'coin',count = 10000})
			
			
			if rpg_t[player.index].xp_uptime_2 >=  game.tick then
				rpg_t[player.index].xp_uptime_2 = rpg_t[player.index].xp_uptime_2 + add_xp_uptime
			else
				rpg_t[player.index].xp_uptime_2 =  game.tick + add_xp_uptime
			end
			local branch = math.floor((rpg_t[player.index].xp_uptime_2 -  game.tick)/60/60) --分
			local second = math.floor((rpg_t[player.index].xp_uptime_2 -  game.tick)/60 - branch * 60)
			game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟双倍经验，2 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		else
			player.print('背包金币不足10K.无法购买双倍经验......')
		end
	end

)
-- --添加4倍经验
-- Gui.on_click(
	-- xp_uptime_4,
	-- function(event)
		-- local player = game.players[event.player_index]
		-- local rpg_t = RPG.get('rpg_t')
		-- local add_xp_uptime = 10 * 60 * 60

		-- if not player.character then
			-- player.print('you are character is nil')
			-- return
		-- end
		
		-- local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		-- if not player_main and not player_main.valid then
			
			-- player.print('you are [player_main] is nil')
			-- return
		-- end
		
		-- local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		-- if coin_number >= 50000 then--玩家背包大于10K
			-- player_main.remove({name = 'coin',count = 50000})
			
			
			-- if rpg_t[player.index].xp_uptime_4 >=  game.tick then
				-- rpg_t[player.index].xp_uptime_4 = rpg_t[player.index].xp_uptime_4 + add_xp_uptime
			-- else
				-- rpg_t[player.index].xp_uptime_4 =  game.tick + add_xp_uptime
			-- end
			-- local branch = math.floor((rpg_t[player.index].xp_uptime_4 -  game.tick)/60/60) --分
			-- local second = math.floor((rpg_t[player.index].xp_uptime_4 -  game.tick)/60 - branch * 60)
			-- game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 4 倍经验，4 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		-- else
			-- player.print('背包金币不足50K.无法购买 4 倍经验......')
		-- end
	-- end

-- )
-- --添加6倍经验
-- Gui.on_click(
	-- xp_uptime_6,
	-- function(event)
		-- local player = game.players[event.player_index]
		-- local rpg_t = RPG.get('rpg_t')
		-- local add_xp_uptime = 10 * 60 * 60

		-- if not player.character then
			-- player.print('you are character is nil')
			-- return
		-- end
		
		-- local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		-- if not player_main and not player_main.valid then
			
			-- player.print('you are [player_main] is nil')
			-- return
		-- end
		
		-- local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		-- if coin_number >= 200000 then--玩家背包大于10K
			-- player_main.remove({name = 'coin',count = 200000})
			
			
			-- if rpg_t[player.index].xp_uptime_6 >=  game.tick then
				-- rpg_t[player.index].xp_uptime_6 = rpg_t[player.index].xp_uptime_6 + add_xp_uptime
			-- else
				-- rpg_t[player.index].xp_uptime_6 =  game.tick + add_xp_uptime
			-- end
			-- local branch = math.floor((rpg_t[player.index].xp_uptime_6 -  game.tick)/60/60) --分
			-- local second = math.floor((rpg_t[player.index].xp_uptime_6 -  game.tick)/60 - branch * 60)
			-- game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 6 倍经验，6 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		-- else
			-- player.print('背包金币不足200K.无法购买 6 倍经验......')
		-- end
	-- end

-- )
-- --添加8倍经验
-- Gui.on_click(
	-- xp_uptime_8,
	-- function(event)
		-- local player = game.players[event.player_index]
		-- local rpg_t = RPG.get('rpg_t')
		-- local add_xp_uptime = 10 * 60 * 60

		-- if not player.character then
			-- player.print('you are character is nil')
			-- return
		-- end
		
		-- local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		-- if not player_main and not player_main.valid then
			
			-- player.print('you are [player_main] is nil')
			-- return
		-- end
		
		-- local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		-- if coin_number >= 500000 then--玩家背包大于10K
			-- player_main.remove({name = 'coin',count = 500000})
			
			
			-- if rpg_t[player.index].xp_uptime_8 >=  game.tick then
				-- rpg_t[player.index].xp_uptime_8 = rpg_t[player.index].xp_uptime_8 + add_xp_uptime
			-- else
				-- rpg_t[player.index].xp_uptime_8 =  game.tick + add_xp_uptime
			-- end
			-- local branch = math.floor((rpg_t[player.index].xp_uptime_8 -  game.tick)/60/60) --分
			-- local second = math.floor((rpg_t[player.index].xp_uptime_8 -  game.tick)/60 - branch * 60)
			-- game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 8 倍经验，8 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		-- else
			-- player.print('背包金币不足500K.无法购买 8 倍经验......')
		-- end
	-- end

-- )
-- --添加10倍经验
-- Gui.on_click(
	-- xp_uptime_10,
	-- function(event)
		-- local player = game.players[event.player_index]
		-- local rpg_t = RPG.get('rpg_t')
		-- local add_xp_uptime = 10 * 60 * 60

		-- if not player.character then
			-- player.print('you are character is nil')
			-- return
		-- end
		
		-- local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		-- if not player_main and not player_main.valid then
			
			-- player.print('you are [player_main] is nil')
			-- return
		-- end
		
		-- local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		-- if coin_number >= 1000000 then--玩家背包大于10K
			-- player_main.remove({name = 'coin',count = 1000000})
			
			
			-- if rpg_t[player.index].xp_uptime_10 >=  game.tick then
				-- rpg_t[player.index].xp_uptime_10 = rpg_t[player.index].xp_uptime_10 + add_xp_uptime
			-- else
				-- rpg_t[player.index].xp_uptime_10 =  game.tick + add_xp_uptime
			-- end
			-- local branch = math.floor((rpg_t[player.index].xp_uptime_10 -  game.tick)/60/60) --分
			-- local second = math.floor((rpg_t[player.index].xp_uptime_10 -  game.tick)/60 - branch * 60)
			-- game.print('玩家【' .. player.name .. '】购买' .. add_xp_uptime/60/60 .. '分钟 10 倍经验，10 倍经验剩余时间：' .. branch .. '分' .. second .. '秒.')
		-- else
			-- player.print('背包金币不足1000000K.无法购买 10 倍经验......')
		-- end
	-- end

-- )
--购买充电
local charge = Gui.uid_name()

Gui.on_click(
    charge,
    function(event)
	
		
        local player = game.players[event.player_index]
	
	
		if not player.character then
			player.print('you are character is nil')
			return
		end
		local armor_inventory = player.get_inventory(defines.inventory.character_armor)
		if not armor_inventory.valid then
			
			player.print('you are [armor_inventory] is nil')
			return
		end
		local armor = armor_inventory[1]
		if not armor.valid_for_read then
			player.print('you are [armor.valid_for_read] not read')
			return
		end
		local grid = armor.grid
		if not grid or not grid.valid then
			player.print('you are [grid.valid] not read')
			return
		end
		local in_energy = 0--10MJ  10000
		local equip = grid.equipment
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		local coin_number = player_main.get_item_count('coin')--获取主空间金币
		
		if coin_number <= 100 and coin_number > 0 then
			in_energy = coin_number * 100000
			player_main.remove({name = 'coin',count = coin_number})
		elseif coin_number > 100 then
			player_main.remove({name = 'coin',count = 100})
			in_energy = 10000000
		else
			goto TT
		end
		
		for _, piece in pairs(equip) do
			if piece.valid and piece.generator_power == 0 then
				local energy_needs = piece.max_energy - piece.energy--energy_needs能量差值
				if energy_needs > 0 then
					if in_energy > 0 then
						if in_energy > energy_needs then
							in_energy = in_energy - energy_needs
							piece.energy = piece.max_energy
						else 
							piece.energy = piece.energy + in_energy
							in_energy = 0
							goto TT
						end
					else
						goto TT
					end
					
				end
			end
		end
		::TT::
		if in_energy > 100000 then 
			player.insert({name = 'coin' ,count = math.floor(in_energy/100000)})--修改
			player.print('返还 ' .. math.floor(in_energy/100000) .. ' 枚金币')
		end
    end
)
--恢复物流区
local ShortcutBarBackup = Gui.uid_name()

Gui.on_click(
    ShortcutBarBackup,
    function(event)
	
		
        local player = game.players[event.player_index]
	
	
		local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
		if window ~= nil then window.destroy() return end
		local window = mod_gui.get_frame_flow(player).add { type = "frame", name = "ShortcutBarAndLogistics_listBackup", direction = "vertical", style = "inner_frame_in_outer_frame", caption = { 'window-label.ShortcutBarAndLogistics_listBackup' } }
		local label_Shortcut_bar = window.add { type = "label", name = "label_Shortcut_bar", caption = { 'window-label.label_Shortcut_bar' }, tooltip = { 'window-label.label_Shortcut_bar_tip' } }
		label_Shortcut_bar.style.single_line = false
		local text_box_Shortcut_bar = window.add { type = "text-box", name = "text_box_Shortcut_bar" }
		text_box_Shortcut_bar.style.height = 40
		text_box_Shortcut_bar.style.width = 400
		text_box_Shortcut_bar.style.top_margin = 4
		text_box_Shortcut_bar.style.bottom_margin = 4
		local button_flow_1 = window.add { type = "flow", name = "button_flow_1", direction = "horizontal" }
		button_flow_1.add { type = "button", name = "button_Shortcut_bar_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_backups' } }
		button_flow_1.add { type = "button", name = "button_Shortcut_bar_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_recovery' } }
		button_flow_1.add { type = "label", name = "box_Shortcut_bar", caption = "", }
		local label_Logistics_list = window.add { type = "label", name = "label_Logistics_list", caption = { 'window-label.label_Logistics_list' }, tooltip = { 'window-label.label_Logistics_list_tip' } }
		label_Logistics_list.style.single_line = false
		local text_box_Logistics_list = window.add { type = "text-box", name = "text_box_Logistics_list" }
		text_box_Logistics_list.text = 
		'eNqlWdtuIzcM/Rc/r4DuLgoU+ytFHzgazoxqXWYpKY632H8vNY6dZO2InBYIYCQ5pCiKl0P6z38OEQIevh1OKY0Y' .. 
		'jV0wl8OnQ3Dx8O03/oRn/vz56YZzlBSoXBC9BpYIZjQF4vEB7nD49ecmWQhiXhMVM6DvnjFBLkYPx+eVMOcdEjWOSDMl/tQZ' ..
		's0fgas4embx6VwqSaIgGeDWgg337Lj7BqDhZhl3P/RB5Hxxv7RgqRSTjYkYSbqjB+BRnswA/wqjSuV1SBXS+KO3MBexxB1JW' .. 
		'fe+2HMB7gx5tIWfNmjz2Dgo4uhr0+MHNenCuA1+kuBR7qNWtKP3flGQuudNF1rCqnETgfE8Rlw4XDde2tYdqWkx2cwQvwuyy' .. 
		'aRTBPtkUUnFPXZdYoDmZE8x9z06+ulGGARXnPdL5Q+gv7uPjZVBeHad9ac2GkK+E+9qDT7PLhYOM0pC6xdKmmAtV2+JMRt/0' ..
		'bq3NgG2+NiulJzdKFeSd5Ao5/0fRl6a5Q2Ko07TrCMLvlT/7Ms1ZrUEqHnOrKh5CPyG4tp4cdS82EzJJkVBAriwBt/ukMLgI' ..
		'7LKewIi2PYISvYUMxKKEr+nEqvPJFbt0cZRmghBg8MjtFuGImkQpKaIZuKAeBZstYem6bYEfQKPRQAknF3Efdod6z52W21e3' ..
		'1lnvpskwTfCpZVJWle4hOS/1TgTuaHFmm7u45IE4jSN2rQRra6heipFYrUfWR8glpQ9dELh8CF1vA+Ez9404a+5bKg2PL/yY' ..
		'VzHKMSMaSXikW7PXCqRpyksiLoy1Xy3a//8Gu3NsuGTLxJcAi/IAowDebvgxts9UuRFgGHzzTgC78CuYz92Iusd/2Yn/2n0B' ..
		'5huXlKVzN/8WDM6CNytna7/FYmQPTVXoWTDoUphTpM9IuHZyuQlprALBfIN76MO3xyK30NbtXTkrVN+j+4/0AP9V6BVj1Zvz' ..
		'AC5emJI9IrMN51PXiVDQ82ioDvy3Z7SlQ79r9fnuls7itiL12YJN68olTUBVgthmHQFGcOLBKy+qUN6s4/QpGvtEHHck5utT' ..
		'RS8XNlEZAzY+OEC/e1TPda878kHbGpyFUV/q4a/OoDqiaTWKLaP+VbkJPp2VWO/mpWixtdGtRgBl7Io8w3jkwJkhK/AXh7Lj' ..
		'gRmpAn+CNuN/iLuPuZdoso1lipnTQuAooubGXE4L9i3FsHLxkW90aagpNvLuyFbX7S0wPkG0jYnKWK6CFnns4k5YYx964X8y' ..
		'7Nr8lfjJn9vp25hpJmp/7A5YWwXmbtdiSFTu08mMGHOr8ZeRtpJGv1QxXmArUNFQWEndtZB++fq7DvaHBtZONRb75LJmDpS6' ..
		'Go3QO4pWSwrbJspk65Djjb3RT4zbQK0VCI6bKNBZLXDjX1qBKwnYcYtamlV6mzIDUELf16SVXZWEsjhcyetcu+SvfZVgJs+/' ..
		'lIXa5N1Vu6Qi6GszPs9SCuRLnniokd+mv/VV2tfm4DY6KQazyfHsSIE5/gw/hNl1dUj2UohqHLNK5pozO0RefMa+E/LyZo9a' ..
		'grtvTArcjVoYrcT1nvtP2Cv5ujgVoZfQ0pkhY4GrWaN2HNnaIDUQQto3as+EEcY+s/W1LRmNAroml9sXj7BmaarjPjimkwo7' ..
		'4oRxW/wpsFykaNvO6DQzOp27qh+srTcWymksroCY2IqwbdDjjiwCLxvKPTATjnfz4+efH69dXpdlBr9Xtwbsrwymmrd9/GUd' ..
		'ppN5mTT2gfkeSgH0xbgQGgtTnoHPKR+ZIvKQqhNgYs5Bzi39ulr/r2LqW8Ut4J7c5u2exLtVSESaW9Vy6EelK96JqM273Yyn' ..
		'UQ69LV0z6mQ5X+0CNOP/FdN+//TLkvEE/Zo+CxN464PM4Klfyy+OkXHvirkMf+1Nu7DNb2UjFh/57M2iZOyvFlYPrXw+/obpr38Bg63qqw=='
		text_box_Logistics_list.style.height = 40
		text_box_Logistics_list.style.width = 400
		text_box_Logistics_list.style.top_margin = 4
		text_box_Logistics_list.style.bottom_margin = 4
		local button_flow_2 = window.add { type = "flow", name = "button_flow_2", direction = "horizontal" }
		button_flow_2.add { type = "button", name = "button_Logistics_list_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_backups' } }
		button_flow_2.add { type = "button", name = "button_Logistics_list_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_recovery' } }
		button_flow_2.add { type = "label", name = "box_Logistics_list", caption = "" }
		window.add { type = "button", name = "back_button", style = "back_button", caption = { 'window-label.back_button' } }


    end
)
--公共物品

local Donationitems_main = Gui.uid_name()

local function add_empty_button(count,this_table)
	for s = 1,count,1 do
		local b = this_table.add {
			type = 'sprite-button',	
		}
		b.style = 'inventory_slot'
		b = nil
	end
end

local function create_contribute_item_this(table1,table2,table3,table4,table5)
	local i = 1
	local frames = {}
	for item_name, item_count in pairs(this.Everybody_items_count) do
		if i > 0 and i <= 65 then
			frames = table1
		elseif i > 65 and i <= 106 then
			frames = table2
		elseif i > 106 and i <= 155 then
			frames = table3
		elseif i > 155 and i <= 220 then
			frames = table4
		elseif i > 220 then
			frames = table5
		end
		local bt =
			frames.add {
			type = 'sprite-button',
			sprite = 'item/' .. item_name,
			number = item_count,
			name = 'Everybody_items_count_' .. item_name,
			tooltip = game.item_prototypes[item_name].localised_name,
			column_count = 2
		}
		bt.enabled = true
		bt.focus()
		bt.style = 'inventory_slot'
		--game.print(bt.get_index_in_parent())
		if i == 4 then
			add_empty_button(6,frames)
		elseif i == 16 then
			add_empty_button(8,frames)
		elseif i == 23 then
			add_empty_button(3,frames)
		elseif i == 30 then
			add_empty_button(3,frames)
		elseif i == 38 then
			add_empty_button(2,frames)
		elseif i == 42 then
			add_empty_button(6,frames)
		elseif i == 50 then
			add_empty_button(2,frames)
		elseif i == 58 then
			add_empty_button(2,frames)
		elseif i == 65 then
			add_empty_button(3,frames)
		elseif i == 72 then
			add_empty_button(3,frames)
		elseif i == 80 then
			add_empty_button(2,frames)
		elseif i == 84 then
			add_empty_button(6,frames)
		elseif i == 87 then
			add_empty_button(7,frames)
		elseif i == 94 then
			add_empty_button(3,frames)
		elseif i == 113 then
			add_empty_button(3,frames)
		elseif i == 121 then
			add_empty_button(2,frames)
		elseif i == 128 then
			add_empty_button(3,frames)
		elseif i == 147 then
			add_empty_button(1,frames)
		elseif i == 171 then
			add_empty_button(4,frames)
		elseif i == 185 then
			add_empty_button(6,frames)
		elseif i == 192 then
			add_empty_button(3,frames)
		elseif i == 197 then
			add_empty_button(5,frames)
		elseif i == 206 then
			add_empty_button(1,frames)
		elseif i == 211 then
			add_empty_button(5,frames)
		end
		i = i +1
	end
end

local function create_contribute_item(tabbed_pane)
			tabbed_pane.selected_tab_index = 1
			local tab1 = tabbed_pane.add{type="tab",name ='tab_物流', caption ='物流',tooltip = '物流'}--item-group/logistics.png[item=tank]icon = "__base__/graphics/technology/item-group.png"
			local tab2 = tabbed_pane.add{type="tab",name ='tab_生产', caption ="生产",tooltip = "生产"}
			local tab3 = tabbed_pane.add{type="tab",name ='tab_零件', caption ="零件",tooltip = "零件"}
			local tab4 = tabbed_pane.add{type="tab",name ='tab_军事', caption ="军事",tooltip = "军事"}
			local tab5 = tabbed_pane.add{type="tab",name ='tab_其他', caption ="其他",tooltip = "其他"}
			
			local table1 = tabbed_pane.add{type = "table",name = 'Logistics', column_count = 10}
			local table2 = tabbed_pane.add{type = "table",name = 'Production', column_count = 10}
			local table3 = tabbed_pane.add{type = "table",name = 'Intermediate', column_count = 10}
			local table4 = tabbed_pane.add{type = "table",name = 'Military', column_count = 10}
			local table5 = tabbed_pane.add{type = "table",name = 'Other', column_count = 10}
			tabbed_pane.add_tab(tab1, table1)
			tabbed_pane.add_tab(tab2, table2)
			tabbed_pane.add_tab(tab3, table3)
			tabbed_pane.add_tab(tab4, table4)
			tabbed_pane.add_tab(tab5, table5)
			table1.style = 'filter_slot_table'
			table2.style = 'filter_slot_table'
			table3.style = 'filter_slot_table'
			table4.style = 'filter_slot_table'
			table5.style = 'filter_slot_table'
			create_contribute_item_this(table1,table2,table3,table4,table5)
end

local function draw_Donationitems_main_frame_for_player(parent, player)
	local frame = parent[Donationitems_main]
    if frame and frame.valid then
		local table1 = frame.allitem.Logistics
		local table2 = frame.allitem.Production
		local table3 = frame.allitem.Intermediate
		local table4 = frame.allitem.Military
		local table5 = frame.allitem.Other
		table1.clear()
		table2.clear()
		table3.clear()
		table4.clear()
		table5.clear()
		create_contribute_item_this(table1,table2,table3,table4,table5)
    else
		local anchor = {gui = defines.relative_gui_type.controller_gui, position = defines.relative_gui_position.left}
		frame = parent.add {
			type = 'frame',
			caption ='玩家：【' .. player.name .. '】打开的公共物品管理界面.',
			direction = 'vertical',
			name = Donationitems_main,
			anchor = anchor,
		}
		if this.players_donationitems_main_location == nil then this.players_donationitems_main_location={} end
		if this.players_donationitems_main_location[player.name] then 
			frame.location = this.players_donationitems_main_location[player.name]
		end
		local tabbed_pane = frame.add{type = "tabbed-pane",name = "allitem"}
		create_contribute_item(tabbed_pane)
	end
end

--十强转化岩石
local stone_wall_to_stone_rock = Gui.uid_name()

Gui.on_click(
	stone_wall_to_stone_rock,
	function(event)
		local alt_key = event.alt 
		local control_key  = event.control 
		local shift_key  = event.shift 
		local player = game.players[event.player_index]
		local surface = player.surface
		local map_name = 'mountain_fortress_v3'
		local number = 1
		local name = 'rock-huge'
		if string.sub(surface.name, 0, #map_name) == map_name then
			local entitys = surface.find_entities_filtered{area = {{x = player.position.x +- 20, y = player.position.y +- 20},{x = player.position.x + 20, y = player.position.y + 20}},name ='stone-wall'}
			for _, entity in pairs (entitys) do
				if control_key and shift_key and alt_key then 
					number = 5
					name = 'tree-01'
				end
				for i = 1 , number,1 do
					surface.create_entity{name = name,position = entity.position}
				end
				entity.destroy()
			end
		end
	end
)

--player_TPpos 玩家传送位置
local player_TPpos = Gui.uid_name()
Gui.on_click(
    player_TPpos,
    function(event)
		local Control = event.control
		local Shift = event.shift
		local player = game.players[event.player_index]
		if Control and Shift then
			this.players_pos[player.name].tp_map_id = player.surface.index
			this.players_pos[player.name].tp_pos = player.position
			player.print('地图管理员:您设置坐标[gps=' .. player.position.x .. ',' .. player.position.y .. ',' .. player.surface.name .. ']为您的特有传送坐标.',{r = 0.75, g = 0.0, b = 0.0})
		else
			-- if this.players_pos[player.name].tp_map_id == 1 then
				-- player.print('地图管理员：您本局游戏未设置传送点.')
				-- return
			-- end
			local surface =game.surfaces[this.players_pos[player.name].tp_map_id]
			if surface == nil then 
				player.print('地图管理员：您当前设置的传送点已无法传送.')
				return
			end
			local tp_pos = this.players_pos[player.name].tp_pos
			local position = surface.find_non_colliding_position('character', tp_pos, 10, 1)
			if position == nil then 
				player.print('地图管理员：您当前设置的传送点已无法传送.')
				return
			end
			player.teleport(position, surface)
			player.print('地图管理员:您传送至您设定的坐标[gps=' .. player.position.x .. ',' .. player.position.y .. ',' .. player.surface.name .. '].',{r = 0.75, g = 0.0, b = 0.0})
		end
	end
)
------------------------------------------------------
local all_ore_to_coal = Gui.uid_name()--添加代码
local all_ore_to_stone = Gui.uid_name()--添加代码
local all_ore_to_iron_ore = Gui.uid_name()--添加代码
local all_ore_to_copper_ore = Gui.uid_name()--添加代码
local all_ore_to_uranium_ore = Gui.uid_name()--添加代码

Gui.on_click(
		all_ore_to_coal,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		--local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = stone_number  + iron_number + copper_number + uranium_number
		
		--if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'coal' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_coal', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_coal0'})--修改
		end
		if control then 
			--local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = stone_number  + iron_number + copper_number + uranium_number
			
			--if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'coal' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_coal', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_coal0'})--修改
			end
		end
    end
	)

Gui.on_click(
    all_ore_to_stone,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		--local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + iron_number + copper_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		--if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'stone' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_stone', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_stone0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			--local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + iron_number + copper_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			--if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'stone' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_stone', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_stone0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_iron_ore,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		--local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + copper_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		--if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'iron-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_iron_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_iron_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			--local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + copper_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			--if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'iron-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_iron_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_iron_ore0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_copper_ore,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		--local copper_number =  player_main.get_item_count('copper-ore')
		local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + iron_number + uranium_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		--if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'copper-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_copper_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_copper_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			--local copper_number =  player_trash.get_item_count('copper-ore')
			local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + iron_number + uranium_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			--if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'copper-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_copper_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_copper_ore0'})--修改
			end
		end
    end
)

Gui.on_click(
    all_ore_to_uranium_ore,
    function(event)
        local player = game.players[event.player_index]
		local icw_locomotive = WPT.get('icw_locomotive')--读取火车数据
		local loco_surface_name = icw_locomotive.surface.name
		if player.surface.name ~= loco_surface_name then 
			player.print({'all_ore_on_locomotive'},{r = 0.75, g = 0.0, b = 0.0})
			return
		end
		local control = event.control
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		player_trash = player.get_inventory(defines.inventory.character_trash)--获取垃圾空间
		--insert(items)  remove(items)  get_item_count(item)
		--[item=coal][item=stone][item=iron-ore][item=copper-ore][item=uranium-ore]
		
		local coal_number =  player_main.get_item_count('coal')
		local stone_number =  player_main.get_item_count('stone')
		local iron_number =  player_main.get_item_count('iron-ore')
		local copper_number =  player_main.get_item_count('copper-ore')
		--local uranium_number =  player_main.get_item_count('uranium-ore')
		local all_ore_number1 = coal_number  + stone_number + iron_number + copper_number
		
		if coal_number > 0 then player_main.remove({name = 'coal',count = coal_number}) end
		if stone_number > 0 then player_main.remove({name = 'stone',count = stone_number}) end
		if iron_number > 0 then player_main.remove({name = 'iron-ore',count = iron_number}) end
		if copper_number > 0 then player_main.remove({name = 'copper-ore',count = copper_number}) end
		--if uranium_number > 0 then player_main.remove({name = 'uranium-ore',count = uranium_number}) end
		
		if all_ore_number1 > 2 then 
			player_main.insert({name = 'uranium-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
			player.print({'all_ore_to_uranium_ore', math.floor(all_ore_number1 * 0.5)})--修改
		else
			player.print({'all_ore_to_uranium_ore0'})--修改
		end
		if control then 
			local coal_number =  player_trash.get_item_count('coal')
			local stone_number =  player_trash.get_item_count('stone')
			local iron_number =  player_trash.get_item_count('iron-ore')
			local copper_number =  player_trash.get_item_count('copper-ore')
			--local uranium_number =  player_trash.get_item_count('uranium-ore')
			local all_ore_number1 = coal_number  + stone_number + iron_number + copper_number
			
			if coal_number > 0 then player_trash.remove({name = 'coal',count = coal_number}) end
			if stone_number > 0 then player_trash.remove({name = 'stone',count = stone_number}) end
			if iron_number > 0 then player_trash.remove({name = 'iron-ore',count = iron_number}) end
			if copper_number > 0 then player_trash.remove({name = 'copper-ore',count = copper_number}) end
			--if uranium_number > 0 then player_trash.remove({name = 'uranium-ore',count = uranium_number}) end
			if all_ore_number1 > 2 then 
				player_trash.insert({name = 'uranium-ore' ,count = math.floor(all_ore_number1 * 0.5)})--修改
				player.print({'all_ore_to_uranium_ore', math.floor(all_ore_number1 * 0.5)})--修改
			else
				player.print({'all_ore_to_uranium_ore0'})--修改
			end
		end
    end
)



function Public.get_player_data(player, remove_user_data)
    if remove_user_data then
        if this.players[player.index] then
            this.players[player.index] = nil
        end
        return
    end
    if not this.players[player.index] then
        this.players[player.index] = {}
    end
    return this.players[player.index]
end

function Public.get(key)
    if key then
        return this[key]
    else
        return this
    end
end

function Public.set(key, value)
    if key and (value or value == false) then
        this[key] = value
        return this[key]
    elseif key then
        return this[key]
    else
        return this
    end
end

Event.on_init(
    function()
        this.players = {}
    end
)

function Public.reset()
    this.players = {}
	--locomotiveitems转名字Everybody_items_count
	--this.Everybody_items_count = {}
	game.print('清空公共区全部物品.')
	this.Everybody_items_count = { 
		['wooden-chest'] = 0,
		['iron-chest'] = 0,
		['steel-chest'] = 0,
		['storage-tank'] = 0,
		['transport-belt'] = 0,
		['fast-transport-belt'] = 0,
		['express-transport-belt'] = 0,
		['underground-belt'] = 0,
		['fast-underground-belt'] = 0,
		['express-underground-belt'] = 0,
		['splitter'] = 0,
		['fast-splitter'] = 0,
		['express-splitter'] = 0,
		['loader'] = 0,
		['fast-loader'] = 0,
		['express-loader'] = 0,
		['burner-inserter'] = 0,
		['inserter'] = 0,
		['long-handed-inserter'] = 0,
		['fast-inserter'] = 0,
		['filter-inserter'] = 0,
		['stack-inserter'] = 0,
		['stack-filter-inserter'] = 0,
		['small-electric-pole'] = 0,
		['medium-electric-pole'] = 0,
		['big-electric-pole'] = 0,
		['substation'] = 0,
		['pipe'] = 0,
		['pipe-to-ground'] = 0,
		['pump'] = 0,
		['rail'] = 0,
		['train-stop'] = 0,
		['rail-signal'] = 0,
		['rail-chain-signal'] = 0,
		['locomotive'] = 0,
		['cargo-wagon'] = 0,
		['fluid-wagon'] = 0,
		['artillery-wagon'] = 0,
		['car'] = 0,
		['tank'] = 0,
		['spidertron'] = 0,
		['spidertron-remote'] = 0,
		['logistic-robot'] = 0,
		['construction-robot'] = 0,
		['logistic-chest-active-provider'] = 0,
		['logistic-chest-passive-provider'] = 0,
		['logistic-chest-storage'] = 0,
		['logistic-chest-buffer'] = 0,
		['logistic-chest-requester'] = 0,
		['roboport'] = 0,
		['small-lamp'] = 0,
		['red-wire'] = 0,
		['green-wire'] = 0,
		['arithmetic-combinator'] = 0,
		['decider-combinator'] = 0,
		['constant-combinator'] = 0,
		['power-switch'] = 0,
		['programmable-speaker'] = 0,
		['stone-brick'] = 0,
		['concrete'] = 0,
		['hazard-concrete'] = 0,
		['refined-concrete'] = 0,
		['refined-hazard-concrete'] = 0,
		['landfill'] = 0,
		['cliff-explosives'] = 0,
		['repair-pack'] = 0,
		['blueprint'] = 0,
		['deconstruction-planner'] = 0,
		['upgrade-planner'] = 0,
		['blueprint-book'] = 0,
		['copy-paste-tool'] = 0,
		['cut-paste-tool'] = 0,
		['boiler'] = 0,
		['steam-engine'] = 0,
		['solar-panel'] = 0,
		['accumulator'] = 0,
		['nuclear-reactor'] = 0,
		['heat-pipe'] = 0,
		['heat-exchanger'] = 0,
		['steam-turbine'] = 0,
		['burner-mining-drill'] = 0,
		['electric-mining-drill'] = 0,
		['offshore-pump'] = 0,
		['pumpjack'] = 0,
		['stone-furnace'] = 0,
		['steel-furnace'] = 0,
		['electric-furnace'] = 0,
		['assembling-machine-1'] = 0,
		['assembling-machine-2'] = 0,
		['assembling-machine-3'] = 0,
		['oil-refinery'] = 0,
		['chemical-plant'] = 0,
		['centrifuge'] = 0,
		['lab'] = 0,
		['beacon'] = 0,
		['speed-module'] = 0,
		['speed-module-2'] = 0,
		['speed-module-3'] = 0,
		['effectivity-module'] = 0,
		['effectivity-module-2'] = 0,
		['effectivity-module-3'] = 0,
		['productivity-module'] = 0,
		['productivity-module-2'] = 0,
		['productivity-module-3'] = 0,
		['rocket-silo'] = 0,
		['satellite'] = 0,
		['wood'] = 0,
		['coal'] = 0,
		['stone'] = 0,
		['iron-ore'] = 0,
		['copper-ore'] = 0,
		['uranium-ore'] = 0,
		['raw-fish'] = 0,
		['iron-plate'] = 0,
		['copper-plate'] = 0,
		['solid-fuel'] = 0,
		['steel-plate'] = 0,
		['plastic-bar'] = 0,
		['sulfur'] = 0,
		['battery'] = 0,
		['explosives'] = 0,
		['crude-oil-barrel'] = 0,
		['heavy-oil-barrel'] = 0,
		['light-oil-barrel'] = 0,
		['lubricant-barrel'] = 0,
		['petroleum-gas-barrel'] = 0,
		['sulfuric-acid-barrel'] = 0,
		['water-barrel'] = 0,
		['copper-cable'] = 0,
		['iron-stick'] = 0,
		['iron-gear-wheel'] = 0,
		['empty-barrel'] = 0,
		['electronic-circuit'] = 0,
		['advanced-circuit'] = 0,
		['processing-unit'] = 0,
		['engine-unit'] = 0,
		['electric-engine-unit'] = 0,
		['flying-robot-frame'] = 0,
		['rocket-control-unit'] = 0,
		['low-density-structure'] = 0,
		['rocket-fuel'] = 0,
		['rocket-part'] = 0,
		['nuclear-fuel'] = 0,
		['uranium-235'] = 0,
		['uranium-238'] = 0,
		['uranium-fuel-cell'] = 0,
		['used-up-uranium-fuel-cell'] = 0,
		['automation-science-pack'] = 0,
		['logistic-science-pack'] = 0,
		['military-science-pack'] = 0,
		['chemical-science-pack'] = 0,
		['production-science-pack'] = 0,
		['utility-science-pack'] = 0,
		['space-science-pack'] = 0,
		['coin'] = 0,
		['pistol'] = 0,
		['submachine-gun'] = 0,
		['tank-machine-gun'] = 0,
		['vehicle-machine-gun'] = 0,
		['tank-flamethrower'] = 0,
		['shotgun'] = 0,
		['combat-shotgun'] = 0,
		['rocket-launcher'] = 0,
		['flamethrower'] = 0,
		['land-mine'] = 0,
		['artillery-wagon-cannon'] = 0,
		['spidertron-rocket-launcher-1'] = 0,
		['spidertron-rocket-launcher-2'] = 0,
		['spidertron-rocket-launcher-3'] = 0,
		['spidertron-rocket-launcher-4'] = 0,
		['tank-cannon'] = 0,
		['firearm-magazine'] = 0,
		['piercing-rounds-magazine'] = 0,
		['uranium-rounds-magazine'] = 0,
		['shotgun-shell'] = 0,
		['piercing-shotgun-shell'] = 0,
		['cannon-shell'] = 0,
		['explosive-cannon-shell'] = 0,
		['uranium-cannon-shell'] = 0,
		['explosive-uranium-cannon-shell'] = 0,
		['artillery-shell'] = 0,
		['rocket'] = 0,
		['explosive-rocket'] = 0,
		['atomic-bomb'] = 0,
		['flamethrower-ammo'] = 0,
		['grenade'] = 0,
		['cluster-grenade'] = 0,
		['poison-capsule'] = 0,
		['slowdown-capsule'] = 0,
		['defender-capsule'] = 0,
		['distractor-capsule'] = 0,
		['destroyer-capsule'] = 0,
		['light-armor'] = 0,
		['heavy-armor'] = 0,
		['modular-armor'] = 0,
		['power-armor'] = 0,
		['power-armor-mk2'] = 0,
		['solar-panel-equipment'] = 0,
		['fusion-reactor-equipment'] = 0,
		['battery-equipment'] = 0,
		['battery-mk2-equipment'] = 0,
		['belt-immunity-equipment'] = 0,
		['exoskeleton-equipment'] = 0,
		['personal-roboport-equipment'] = 0,
		['personal-roboport-mk2-equipment'] = 0,
		['night-vision-equipment'] = 0,
		['energy-shield-equipment'] = 0,
		['energy-shield-mk2-equipment'] = 0,
		['personal-laser-defense-equipment'] = 0,
		['discharge-defense-equipment'] = 0,
		['discharge-defense-remote'] = 0,
		['stone-wall'] = 0,
		['gate'] = 0,
		['gun-turret'] = 0,
		['laser-turret'] = 0,
		['flamethrower-turret'] = 0,
		['artillery-turret'] = 0,
		['artillery-targeting-remote'] = 0,
		['radar'] = 0,
		['player-port'] = 0,
		['electric-energy-interface'] = 0,
		['linked-chest'] = 0,
		['heat-interface'] = 0,
		['linked-belt'] = 0,
		['infinity-chest'] = 0,
		['infinity-pipe'] = 0,
		['selection-tool'] = 0,
		['item-with-inventory'] = 0,
		['item-with-label'] = 0,
		['item-with-tags'] = 0,
		['simple-entity-with-force'] = 0,
		['simple-entity-with-owner'] = 0,
		['burner-generator'] = 0,
	}
	this.bottom_quickbar_button_112 = {}
	this.players_donationitems_main_location = {}
	this.players_pos = {}
	game.forces.player.technologies["logistic-robotics"].researched = true
	for _, player in ipairs(game.connected_players) do
		if not this.players_pos[player.name]  then
			this.players_pos[player.name] = {tp_map_id = 1 , tp_pos = {x = 1, y = 1}}
		end
		if player.gui.screen['Donationitems_main' .. player.name] then 
			player.gui.screen['Donationitems_main' .. player.name].destroy()
		end
	end
end

----! 商店界面创建 ! ----
local function create_frame(player, rebuild)
    local gui = player.gui
    local frame = gui.screen[bottom_guis_frame_111]
    if frame and frame.valid then
        if rebuild then
            frame.destroy()
        else
            return frame
        end
    end

    frame =
        player.gui.screen.add {
        type = 'frame',
        name = bottom_guis_frame_111,
		caption = '商店',
        direction = 'vertical'
    }
	
    frame.style.padding = 3
    frame.style.top_padding = 4
			
    local inner_frame_112 =
        frame.add {
        type = 'frame',
        direction = 'horizontal',--横向 
		style = 'deep_frame_in_shallow_frame'
    }
    local inner_frame_113 =
        frame.add {
        type = 'frame',
        direction = 'horizontal',--横向 
		style = 'deep_frame_in_shallow_frame'
    }
    local inner_frame_114 =
    frame.add {
        type = 'frame',
        direction = 'horizontal',--横向 
		style = 'deep_frame_in_shallow_frame'
    }
	
	
	inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'item/battery-mk2-equipment',
        name = charge,
        tooltip = {'charge'},
        style = 'quick_bar_page_button'
    }
	
	inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'virtual-signal/signal-B',
        name = ShortcutBarBackup,
        tooltip = {'ShortcutBarBackup'},
        style = 'quick_bar_page_button'
    }

	--石墙转化巨岩
inner_frame_112.add {
        type = 'sprite-button',
        sprite = 'entity/rock-huge',
        name = stone_wall_to_stone_rock,
        tooltip = {'stone_wall_to_stone_rock'},
        style = 'quick_bar_page_button'
    }

	--player_TPpos 玩家TP位置
inner_frame_112.add {
        type = 'sprite-button',
        caption = 'POS',
        name = player_TPpos,
        tooltip = {'player_TPpos'},
        style = 'quick_bar_page_button'
    }
	
	inner_frame_113.add {
        type = 'sprite-button',
        sprite = 'item/coal',
        name = all_ore_to_coal,
        tooltip = {'all_ore_to_coal1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_113.add {
        type = 'sprite-button',
        sprite = 'item/stone',
        name = all_ore_to_stone,
        tooltip = {'all_ore_to_stone1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_113.add {
        type = 'sprite-button',
        sprite = 'item/iron-ore',
        name = all_ore_to_iron_ore,
        tooltip = {'all_ore_to_iron_ore1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_113.add {
        type = 'sprite-button',
        sprite = 'item/copper-ore',
        name = all_ore_to_copper_ore,
        tooltip = {'all_ore_to_copper_ore1'},
        style = 'quick_bar_page_button'
    }
    inner_frame_113.add {
        type = 'sprite-button',
        sprite = 'item/uranium-ore',
        name = all_ore_to_uranium_ore,
        tooltip = {'all_ore_to_uranium_ore1'},
        style = 'quick_bar_page_button'
    }
	

	inner_frame_114.add {
        type = 'sprite-button',
        caption = '2倍',
        name = xp_uptime_2,
        tooltip = {'xp_uptime_2'},
        style = 'quick_bar_page_button'
    }
	-- inner_frame_114.add {
        -- type = 'sprite-button',
        -- caption = '4倍',
        -- name = xp_uptime_4,
        -- tooltip = {'xp_uptime_4'},
        -- style = 'quick_bar_page_button'
    -- }
	-- inner_frame_114.add {
        -- type = 'sprite-button',
        -- caption = '6倍',
        -- name = xp_uptime_6,
        -- tooltip = {'xp_uptime_6'},
        -- style = 'quick_bar_page_button'
    -- }
	-- inner_frame_114.add {
        -- type = 'sprite-button',
        -- caption = '8倍',
        -- name = xp_uptime_8,
        -- tooltip = {'xp_uptime_8'},
        -- style = 'quick_bar_page_button'
    -- }
	-- inner_frame_114.add {
        -- type = 'sprite-button',
        -- caption = '10倍',
        -- name = xp_uptime_10,
        -- tooltip = {'xp_uptime_10'},
        -- style = 'quick_bar_page_button'
    -- }
	
	
	
    -- this.bottom_quickbar_button_112[player.index] = {name = bottom_quickbar_button_name_112, frame = bottom_quickbar_button_112}

    -- if this.bottom_quickbar_button_112.sprite and this.bottom_quickbar_button_112.tooltip then
        -- bottom_quickbar_button_112.sprite = this.bottom_quickbar_button_112.sprite
        -- bottom_quickbar_button_112.tooltip = this.bottom_quickbar_button_112.tooltip
    -- end

    return frame
end
--设置显示位置
local function set_location(player)
    local frame = create_frame(player)
	--frame.auto_center = true
    local resolution = player.display_resolution
    local scale = player.display_scale

    if this.players[player.index] and this.players[player.index].bottom_left then
        frame.location = {
            x = (resolution.width / 2) - ((54 + 445) * scale),
            y = (resolution.height - (144 * scale))--底部0 1格 48
        }
        return
    end

    if this.bottom_right then
        frame.location = {
            x = (resolution.width / 2) - ((54 + -576) * scale),
            y = (resolution.height - (168 * scale))--底部0 1格 48
        }
    else
        local experimental = get_game_version()
        if experimental then
            frame.location = {
                x = (resolution.width / 2) - ((54 + 620) * scale),
                y = (resolution.height - (184 * scale))--底部0 1格 48
            }
        else
            frame.location = {
                x = (resolution.width / 2) - ((54 + 58) * scale),
                y = (resolution.height - (144 * scale))--底部0 1格 48
            }
        end
    end
end

--- Activates the custom buttons
---@param boolean
function Public.activate_custom_buttons(value)
    if value then
        this.activate_custom_buttons = value
    else
        this.activate_custom_buttons = false
    end
end

--- Fetches if the custom buttons are activated
function Public.is_custom_buttons_enabled()
    return this.activate_custom_buttons
end

--- Sets the buttons to be aligned bottom right
---@param boolean
function Public.bottom_right(value)
    if value then
        this.bottom_right = value
    else
        this.bottom_right = false
    end
end


local function red_chest_inst(chest,item_name)
	local item_number = this.Everybody_items_count[item_name]
	local chest_inventory = chest.get_inventory(defines.inventory.chest) --
	if item_number > 0 then
		local insert_itme_number = chest_inventory.insert({name = item_name ,count = item_number})
		this.Everybody_items_count[item_name] = this.Everybody_items_count[item_name] - insert_itme_number
	end
end

local function blue_chest_inst(chest,data)
	if chest.request_from_buffers then
		for slot_index = 1, 5, 1 do
			local stack = chest.get_request_slot(slot_index)
			if stack then
				local chest_inventory = chest.get_inventory(defines.inventory.chest) --
				local number1 = stack.count
				local number2 = chest.get_item_count(stack.name)
				local number3 = number1 - number2
				local number4 = data.Everybody_items_count[stack.name]
				if number3 > 0 and number3 <= number4 then
					local now_stack = chest_inventory.insert({name = stack.name, count = number3})
					data.Everybody_items_count[stack.name] = data.Everybody_items_count[stack.name] - now_stack
				elseif number3 > 0 and number4 > 0 and number3 > number4 then 
					local now_stack = chest_inventory.insert({name = stack.name, count = number4})
					data.Everybody_items_count[stack.name] = data.Everybody_items_count[stack.name] - now_stack
				end
			end
		end
	end
end
--tablelong(thistable)计算tabel长度
local function tablelong(thistable)
	local l = 0
	for _,_ in pairs(thistable)do
		l=l+1
	end
	return l
end

local function locomotive_inst_item()

	local blue_chest = WPT.get('blue_chest')
	local red_chest = WPT.get('red_chest')
	if red_chest['red-chest-1-1'] == nil then return end
	local name = {"coal",'stone','iron-ore','copper-ore','uranium-ore'}
	for x = 1,5,1 do
		for y = 1,tablelong(red_chest)/5,1 do
			red_chest_inst(red_chest['red-chest-' .. x .. '-' .. y],name[x])
		end
	end
	-- for _, chest in pairs(blue_chest) do
		-- blue_chest_inst(chest,this)
	-- end
end


--on_gui_click
Event.add(
    defines.events.on_gui_click,
    function(event)
		if not event then
			return
		end
		--game.print('直接界面' .. event.element.name)
		--game.print('父级' .. event.element.parent.name)
		if not event.element then
			return
		end
		if not event.element.valid then
			return
		end
		if not event.element.name then
			return
		end
		local player = game.players[event.player_index]
		
		
		local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
		
		
		--Everybody items count)
		local out_item = 'Everybody_items_count_'
		if string.sub(event.element.name, 0, #out_item) == out_item and player.character and player.character.valid then
			local item_name = string.sub(event.element.name, #out_item + 1, #event.element.name)
			local prototypes = game.item_prototypes
			
			if event.button == defines.mouse_button_type.left and this.Everybody_items_count[item_name] >= 1 then
				player.insert({name = item_name, count = 1})
				this.Everybody_items_count[item_name] = this.Everybody_items_count[item_name] - 1
				game.print('玩家：' .. player.name .. ' 在公共区拿取物 [item=' .. item_name .. '] ' .. 1 .. ' 个.' ,{r = 255,g = 0,b = 255})
			elseif event.button == defines.mouse_button_type.right and this.Everybody_items_count[item_name] >= prototypes[item_name].stack_size then 
				local number = 0
				if event.control then 
					number = player.insert({name = item_name, count = this.Everybody_items_count[item_name]})
				else
					number = player.insert({name = item_name, count = prototypes[item_name].stack_size})
				end
				this.Everybody_items_count[item_name] = this.Everybody_items_count[item_name] - number
				game.print('玩家：' .. player.name .. ' 在公共区拿取物 [item=' .. item_name .. '] ' .. number .. ' 个.' ,{r = 255,g = 0,b = 255})
			elseif this.Everybody_items_count[item_name] < prototypes[item_name].stack_size and this.Everybody_items_count[item_name] >=1 then
				local number = player.insert({name = item_name, count = this.Everybody_items_count[item_name]})
				this.Everybody_items_count[item_name] = this.Everybody_items_count[item_name] - number
				game.print('玩家：' .. player.name .. ' 在公共区拿取物 [item=' .. item_name .. '] ' .. number .. ' 个.' ,{r = 255,g = 0,b = 255})
			elseif this.Everybody_items_count[item_name] == 0 then
				player.print('公共区[item=' .. item_name .. '] 为0',{r = 255,g = 0,b = 255})
			end
		end
		if event.element.type == "text-box" then
			event.element.select_all()
		elseif event.element.name == 'button_Shortcut_bar_backups' then
			local text_box = window['text_box_Shortcut_bar']
			text_box.text = get_Shortcut_bar_text(player)
			text_box.select_all()
			text_box.focus()
		elseif event.element.name == 'button_Shortcut_bar_recovery' then
			local text_box = window['text_box_Shortcut_bar']
			local encoded_string = text_box.text
			if encoded_string == "" then
				dump("字符串解码失败，请重新输入", player)
				text_box.focus()
				return
			else
				local decoded_string = game.decode_string(encoded_string)
				if decoded_string == nil then
					dump("字符串解码失败，请重新输入", player)
					text_box.focus()
					return
				else
					if type(game.json_to_table(decoded_string)) ~= "table" then
						dump("非法的字符串，请重新输入", player)
						text_box.focus()
						return
					end
					for index, name in ipairs(game.json_to_table(decoded_string)) do
						local status = pcall(recovery_Shortcut_bar, player, index, name)
						if not status then
							dump("【" .. name .. "】物品已经不存在了")
						end
					end
				end
			end
			dump(player.name .. "恢复快捷栏成功")
		elseif event.element.name == 'button_Logistics_list_backups' then
			-- if DoesRobotResearch(player.force) == false then
				-- dump("解锁物流机器人后才能使用此功能")
				-- return
			-- end
			local text_box = window["text_box_Logistics_list"]
			text_box.text = get_Logistics_list_text(player)
			text_box.select_all()
			text_box.focus()
		elseif event.element.name == 'button_Logistics_list_recovery' then
			-- if DoesRobotResearch(player.force) == false then
				-- dump("解锁物流机器人后才能使用此功能")
				-- return
			-- end
			local text_box = window['text_box_Logistics_list']
			local encoded_string = text_box.text
			if encoded_string == "" then
				dump("字符串解码失败，请重新输入", player)
				text_box.focus()
				return
			else
				local decoded_string = game.decode_string(encoded_string)
				if decoded_string == nil then
					dump("字符串解码失败，请重新输入", player)
					text_box.focus()
					return
				else
					local pl_slots = game.json_to_table(decoded_string)
					if type(pl_slots) ~= "table" then
						dump("非法的字符串，请重新输入", player)
						text_box.focus()
						return
					end
					for index, slot in ipairs(pl_slots) do
						local status = pcall(recovery_Logistics_list, player, index, slot)
						if not status then
	--                        dump("【" .. name .. "】物品已经不存在了")
						end
					end
				end
			end
			dump(player.name .. '恢复物流需求列表成功')
		elseif event.element.name == 'back_button' then
			window.destroy()
		end
    end
)
--on_gui_opened
Event.add(
    defines.events.on_gui_opened,
	function(event)
        local player = game.get_player(event.player_index)
        if not player or not player.valid then
            return
        end
        local panel = player.gui.relative
		if event.gui_type == defines.gui_type.controller then
            draw_Donationitems_main_frame_for_player(panel, player)
        end
	end
)
--on_gui_closed
-- Event.add(defines.events.on_gui_closed, function(event)
	-- local player = game.get_player(event.player_index)
	-- if not player or not player.valid then
		-- return
	-- end
	-- if not event.gui_type == defines.gui_type.controller then
		-- return
	-- end
	-- local relative = player.gui.relative
	-- local frame = relative[Donationitems_main]
	-- if frame and frame.valid then
		-- Gui.destroy(frame)
	-- end
-- end)

--on_player_joined_game
Event.add(
    defines.events.on_player_joined_game,
    function(event)
        local player = game.players[event.player_index]
        if this.activate_custom_buttons then
            set_location(player)
        end
		local panel = player.gui.relative
		local frame = panel[Donationitems_main]
		if frame and frame.valid then
			frame.destroy()
		end
    end
)

Event.add(
    defines.events.on_player_display_resolution_changed,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_player_respawned,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(
    defines.events.on_player_died,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            local frame = player.gui.screen[bottom_guis_frame_111]
            if frame and frame.valid then
                frame.destroy()
            end
        end
    end
)

Event.add(
    defines.events.on_player_display_scale_changed,
    function(event)
        local player = game.get_player(event.player_index)
        if this.activate_custom_buttons then
            set_location(player)
        end
    end
)

Event.add(defines.events.on_player_mined_entity, 
    function(event)
	local entity = event.entity
	if not entity or not entity.valid then return end
	local this_type = entity.type
	local position = event.entity.position
		if (position.x == 255.5 or position.x == -255.5)  and (this_type == 'simple-entity' or this_type == 'tree') then
			local name = event.entity.name
			local surface = event.entity.surface
			surface.create_entity{name = name ,position = position}
		end
	end
)

local function tick()
    local ticker = game.tick
    if ticker % 300 == 0 then
		locomotive_inst_item()
		if ticker > 600 then
			for _,player in pairs(game.connected_players) do
				local character = player.character
				if character and character.valid then
					local player_trash = player.get_inventory(defines.inventory.character_trash)
					if player_trash and player_trash.valid then
						if not player_trash.is_empty() then
							Public.chest_item_inst_Everybody_items_count(player_trash)
						end
					end
				end
			end
		end
    end
	-- if  ticker % 18000 == 0 then
		-- game.forces.player.technologies["logistic-robotics"].researched = true
		-- --local locomotiveitems = WPT.get('locomotiveitems')
		-- local map_name = 'mountain_fortress_v3'
		-- game.print('清理地图所有 【宝箱物品】.【地图矿物资源】【玩家回收区】到公共仓库(5分钟/次) 时间：' .. math.floor(ticker/3600) .. '分',{r = 255,g = 0,b = 0})
		-- for _, surface in pairs(game.surfaces) do
			-- if string.sub(surface.name, 0, #map_name) == map_name then
				-- for chunk in surface.get_chunks() do
					-- if chunk.x < 8 and chunk.x > -9 then
						-- for _, chests in pairs(surface.find_entities_filtered{area=chunk.area, type='container',force = 'neutral'}) do
							
							-- if not chests or not chests.valid then
								-- goto continue
							-- end
							-- local chests_inventory = chests.get_inventory(defines.inventory.chest)
							-- if not chests_inventory or not chests_inventory.valid then
								-- goto continue
							-- end
							-- if chests_inventory.is_empty() then
								-- chests.damage(9999999999, 'enemy', 'explosion')
								-- goto continue
							-- end
							-- Public.chest_item_inst_Everybody_items_count(chests_inventory)
							-- chests.damage(9999999999, 'enemy', 'explosion')
							-- ::continue::
						-- end
						-- for _, resource in pairs(surface.find_entities_filtered{area=chunk.area, type='resource',force = 'neutral'}) do
							-- if resource.name ~= 'crude-oil' then
								-- this.Everybody_items_count[resource.name] = this.Everybody_items_count[resource.name] + resource.amount
								-- resource.deplete()
							-- end
						-- end
					-- end
				-- end
			-- end
		-- end
	-- end
end




local function on_player_joined_game(event)
	local player = game.players[event.player_index]
	if not this.players_pos[player.name]  then
		this.players_pos[player.name] = {tp_map_id = 1 , tp_pos = {x = 1, y = 1}}
	end
end

Event.on_nth_tick(5, tick)
Event.add(defines.events.on_player_joined_game, on_player_joined_game)
Public.bottom_guis_frame_111 = bottom_guis_frame_111
Public.set_location = set_location
ComfyGui.screen_to_bypass(bottom_guis_frame_111)

return Public
