--
-- Created by IntelliJ IDEA.
-- User: xiangyang-nice
-- Date: 2020/12/26
-- Time: 12:51
-- To change this template use File | Settings | File Templates.
--
StringHelper = {}

function StringHelper.split(str, reps)
    local resultStrList = {}
    string.gsub(str, '[^' .. reps .. ']+', function(w)
        table.insert(resultStrList, w)
    end)
    return resultStrList
end

function StringHelper.Sub(str, startIndex, endIndex)
    local tempStr = str
    local byteStart = 1 -- string.sub截取的开始位置
    local byteEnd = -1 -- string.sub截取的结束位置
    local index = 0 -- 字符记数
    local bytes = 0 -- 字符的字节记数

    startIndex = math.max(startIndex, 1)
    endIndex = endIndex or -1
    while string.len(tempStr) > 0 do
        if index == startIndex - 1 then
            byteStart = bytes + 1;
        elseif index == endIndex then
            byteEnd = bytes;
            break;
        end
        bytes = bytes + StringHelper.GetBytes(tempStr)
        tempStr = string.sub(str, bytes + 1)

        index = index + 1
    end
    return string.sub(str, byteStart, byteEnd)
end

function StringHelper.GetBytes(char)
    if not char then
        return 0
    end
    local code = string.byte(char)
    if code < 127 then
        return 1
    elseif code <= 223 then
        return 2
    elseif code <= 239 then
        return 3
    elseif code <= 247 then
        return 4
    else
        -- 讲道理不会走到这里^_^
        return 0
    end
end

-- 输出调试信息
function dump(message, force)
    if force then
        force.print(message, { r = 255, g = 0, b = 255 })
    else
        game.print(message, { r = 255, g = 0, b = 255 })
    end
end

function Count(list)
    local i = 0
    for _ in pairs(list) do
        i = i + 1
    end
    return i
end

function Contains(tab,elem)
    for _,v in pairs(tab) do
        if v == elem then
            return true
        elseif type(v) == "table" then
            if Contains(v,elem) then
                return true
            end
        end
    end
    return false
end

function Remove(tab,elem)
    for i,v in pairs(tab) do
        if v == elem then
            table.remove(tab,i)
            return true
        end
    end
    return false
end

function DoesRobotResearch(force)
	--game.players[1].force.technologies["logistic-robotics"].researched = true
    for _, research in pairs(force.technologies) do
        if research.researched then
            if research.name == "logistic-robotics" then
                return true
            end
        end
    end
    return false
end

function get_Shortcut_bar_text(player)
    local list = {}
    for i = 1, 100 do
        local slot = player.get_quick_bar_slot(i)
        if slot ~= nil then
            table.insert(list, slot.name)
        else
            table.insert(list, "")
        end
    end
    return game.encode_string(game.table_to_json(list))
--    return game.table_to_json(list)
end

function recovery_Shortcut_bar(player, index, name)
    if name ~= "" then
        player.set_quick_bar_slot(index, name)
    else
        player.set_quick_bar_slot(index, nil)
    end
end

function get_Logistics_list_text(player)
    if DoesRobotResearch(player.force) == false then
        return ""
    end
    local list = {}
    local empty = true
    for i = 1, player.character.request_slot_count do
        local slot = player.get_personal_logistic_slot(i)
        if slot.name ~= nil then
            table.insert(list, slot)
            empty = false;
        else
            table.insert(list, "")
        end
    end
    if not empty then
        return game.encode_string(game.table_to_json(list))
--        return game.table_to_json(list)
    else
        return ""
    end
end

function recovery_Logistics_list(player, index, slot)
    if slot ~= "" then
        player.set_personal_logistic_slot(index, slot)
    else
        player.set_personal_logistic_slot(index, { name = nil })
    end
end
