local mod_gui = require("mod-gui")
local Event = require 'utils.event'
require("baseapi")
PlayerList = {}



-- 视图缩放


-- 资源枯竭时在当前位置创建资源，变向的无限资源

-- 聊天栏信息


-- 电量修改


--  在研究完成时调用。


-- 	按下自定义Lua快捷方式时调用
script.on_event(defines.events.on_lua_shortcut, function(event)
    local player = game.players[event.player_index]
    --    if event.prototype_name == 'InfiniteResearch' then
    --        local switch = not player.is_shortcut_toggled('InfiniteResearch')
    --        player.set_shortcut_toggled('InfiniteResearch', switch)
    if event.prototype_name == 'ShortcutBarBackup' then
        ShortcutBarBackup(player)
    end
end)

function ShortcutBarBackup(player)
    local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
    if window ~= nil then window.destroy() return end
    local window = mod_gui.get_frame_flow(player).add { type = "frame", name = "ShortcutBarAndLogistics_listBackup", direction = "vertical", style = "inner_frame_in_outer_frame", caption = { 'window-label.ShortcutBarAndLogistics_listBackup' } }
    local label_Shortcut_bar = window.add { type = "label", name = "label_Shortcut_bar", caption = { 'window-label.label_Shortcut_bar' }, tooltip = { 'window-label.label_Shortcut_bar_tip' } }
    label_Shortcut_bar.style.single_line = false
    local text_box_Shortcut_bar = window.add { type = "text-box", name = "text_box_Shortcut_bar" }
    text_box_Shortcut_bar.style.height = 40
    text_box_Shortcut_bar.style.width = 400
    text_box_Shortcut_bar.style.top_margin = 4
    text_box_Shortcut_bar.style.bottom_margin = 4
    local button_flow_1 = window.add { type = "flow", name = "button_flow_1", direction = "horizontal" }
    button_flow_1.add { type = "button", name = "button_Shortcut_bar_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_backups' } }
    button_flow_1.add { type = "button", name = "button_Shortcut_bar_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Shortcut_bar_recovery' } }
    button_flow_1.add { type = "label", name = "box_Shortcut_bar", caption = "", }
    local label_Logistics_list = window.add { type = "label", name = "label_Logistics_list", caption = { 'window-label.label_Logistics_list' }, tooltip = { 'window-label.label_Logistics_list_tip' } }
    label_Logistics_list.style.single_line = false
    local text_box_Logistics_list = window.add { type = "text-box", name = "text_box_Logistics_list" }
    text_box_Logistics_list.style.height = 40
    text_box_Logistics_list.style.width = 400
    text_box_Logistics_list.style.top_margin = 4
    text_box_Logistics_list.style.bottom_margin = 4
    local button_flow_2 = window.add { type = "flow", name = "button_flow_2", direction = "horizontal" }
    button_flow_2.add { type = "button", name = "button_Logistics_list_backups", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_backups' } }
    button_flow_2.add { type = "button", name = "button_Logistics_list_recovery", direction = "horizontal", style = "confirm_button", caption = { 'window-label.button_Logistics_list_recovery' } }
    button_flow_2.add { type = "label", name = "box_Logistics_list", caption = "" }
    window.add { type = "button", name = "back_button", style = "back_button", caption = { 'window-label.back_button' } }

end

--  界面被点击
script.on_event(defines.events.on_gui_click, function(event)
    local player = game.players[event.player_index]
    local window = mod_gui.get_frame_flow(player)["ShortcutBarAndLogistics_listBackup"]
    if event.element.type == "text-box" then
        event.element.select_all()
    elseif event.element.name == 'button_Shortcut_bar_backups' then
        local text_box = window['text_box_Shortcut_bar']
        text_box.text = get_Shortcut_bar_text(player)
        text_box.select_all()
        text_box.focus()
    elseif event.element.name == 'button_Shortcut_bar_recovery' then
        local text_box = window['text_box_Shortcut_bar']
        local encoded_string = text_box.text
        if encoded_string == "" then
            dump("字符串解码失败，请重新输入", player)
            text_box.focus()
            return
        else
            local decoded_string = game.decode_string(encoded_string)
            if decoded_string == nil then
                dump("字符串解码失败，请重新输入", player)
                text_box.focus()
                return
            else
                if type(game.json_to_table(decoded_string)) ~= "table" then
                    dump("非法的字符串，请重新输入", player)
                    text_box.focus()
                    return
                end
                for index, name in ipairs(game.json_to_table(decoded_string)) do
                    local status = pcall(recovery_Shortcut_bar, player, index, name)
                    if not status then
                        dump("【" .. name .. "】物品已经不存在了")
                    end
                end
            end
        end
        dump("恢复快捷栏成功")
    elseif event.element.name == 'button_Logistics_list_backups' then
        if DoesRobotResearch(player.force) == false then
            dump("解锁物流机器人后才能使用此功能")
            return
        end
        local text_box = window["text_box_Logistics_list"]
        text_box.text = get_Logistics_list_text(player)
        text_box.select_all()
        text_box.focus()
    elseif event.element.name == 'button_Logistics_list_recovery' then
        if DoesRobotResearch(player.force) == false then
            dump("解锁物流机器人后才能使用此功能")
            return
        end
        local text_box = window['text_box_Logistics_list']
        local encoded_string = text_box.text
        if encoded_string == "" then
            dump("字符串解码失败，请重新输入", player)
            text_box.focus()
            return
        else
            local decoded_string = game.decode_string(encoded_string)
            if decoded_string == nil then
                dump("字符串解码失败，请重新输入", player)
                text_box.focus()
                return
            else
                local pl_slots = game.json_to_table(decoded_string)
                if type(pl_slots) ~= "table" then
                    dump("非法的字符串，请重新输入", player)
                    text_box.focus()
                    return
                end
                for index, slot in ipairs(pl_slots) do
                    local status = pcall(recovery_Logistics_list, player, index, slot)
                    if not status then
--                        dump("【" .. name .. "】物品已经不存在了")
                    end
                end
            end
        end
        dump("恢复物流需求列表成功")
    elseif event.element.name == 'back_button' then
        window.destroy()
    end
end)


Event.add(defines.events.on_gui_click, on_gui_click)





